﻿function getCharCount(strBf, compChar)
{
    var charNum = 0;

    if((strBf == undefined) || (compChar == undefined)) {
        return charNum;
    }
    
    for(var i = 0; i < strBf.length; i++) {
        if(strBf.charAt(i) == compChar) {
            charNum++;
        }
    }
    //--- alert('lf num :' + charNum);
    return charNum;
}

function _mysql_real_escape_string (strBf) 
{
    return strBf.replace(/[\0\x08\x09\x1a\n\r"'\\\%]/g, function (char) 
    {
        switch (char) {
            case "\0": return "\\0";
            case "\x08": return "\\b";
            case "\x09": return "\\t";
            case "\x1a": return "\\z";
            case "\n": return "\\n";
            case "\r":return "\\r";
            case "\"":
            case "'":
            case "\\":
            case "%":
                return "\\"+char; // prepends a backslash to backslash, percent, and double/single quotes
        }
    });
}

function getPairKeyValue(strBf, key)
{
    var keyValue = "";

    if(strBf == undefined) {
        return keyValue;
    }

    var Find_Pos = strBf.indexOf(key);
    if(Find_Pos < 0) {
        return keyValue;
    }
    keyValue = strBf.slice(Find_Pos + key.length);
    if(keyValue.length >= 2) {
        // 내부적으로 추가된 맨 뒤에 "\r\n" 길이를 지운다.
        while(keyValue.length > 0) {
            if(keyValue.charAt(keyValue.length - 1) == '\r') {
                keyValue = keyValue.slice(0, -1);
            }
            else if(keyValue.charAt(keyValue.length - 1) == '\n') {
                keyValue = keyValue.slice(0, -1);
            }
            else {
                break;
            }
        }
    } 
    //--- console.log('keyValue :' + keyValue);
    return keyValue;
}

function copy_clipboard(copyText) {
    window.prompt("Copy to clipboard: Ctrl+C / Cmd+C, Enter", copyText);
}

function move_progbar(pos) {
    var ProgBar = document.getElementById('DsmProgressBar');
    ProgBarWidth = Math.round(pos);
    if(ProgBarWidth > 100) {
        ProgBarWidth = 100;
    }
    else if(ProgBarWidth < 0) {
        ProgBarWidth = 0;
    }
    ProgBar.style.width = ProgBarWidth + '%';
    document.getElementById("DsmProgressLabel").innerHTML = Math.round(ProgBarWidth) + '%';    
}

function reloadPage() {
    location.reload();
}

function urldecode(strVar) 
{ 
    if (typeof strVar != "string") { 
        return strVar; 
    } 
    if(strVar.length <= 0) {
        return strVar;
    }
    var replaceString = strVar.replace(/\+/g, ' ');
    var decodeStr = decodeURIComponent(replaceString);
    return decodeStr; 
}

function isAlphaNumer(checkBf)
{
    var typeCheck = typeof checkBf;
    if(typeCheck !== "string") {
        return false;
    }
    if(checkBf.length != 1) {
        return false;
    }
    if((checkBf >= "a" && checkBf <= "z")) {
        return true;
    }
    if((checkBf >= "A" && checkBf <= "Z")) {
        return true;
    }
    if((checkBf >= "0" && checkBf <= "9")) {
        return true;
    }
    return false; 
}
