//-function getTwitList_lastest() 
//-{   // 타이머용으로 만든 것
//-    var from_latest = true;
//-    getTwitList(from_latest);
//-}

function getTwitList(from_latest = false, par_listing_num = 0) 
{
    var id_tweet_working_daylist = document.getElementById('tweet_working_daylist');
    if(id_tweet_working_daylist != null) {
        if(id_tweet_working_daylist.value.length >= 1) { // (개별 날짜 트윗 목록이 아니라) 일짜별 트윗 목록
            catchTwitDayList();
            return;
        }
    }

    //-----
    if(CheckWorkEnd(from_latest) == true) {
        return true;
    }

    //---
    CountTimeElapse(); // time-view

    //---
    if(check_dbtable_field() == false) {
        alert('error: check db-table');
        return false;
    }

    // db-rec-num 읽어둔다.
    getTwitTable_RecNum();

    //-------------
    //--- var_check
    //-------------
    var id_listing_num = document.getElementById('btn_listing_num');
    if(id_listing_num == null) {
        return;
    }
    var listing_num = parseInt(id_listing_num.value);
    if(listing_num < 1) {
        alert('error: (listing_num < 1)');
        return false;
    }
    par_listing_num = parseInt(par_listing_num);
    if(par_listing_num > 0) { // 외부에서 매개변수로 읽을 개수를 지정했으면 이것을 사용
        listing_num = par_listing_num;
    }

    // call
    catchTwitList(listing_num, from_latest);

    //
    return true;
}

function catchTwitList(twitListingNum, from_latest = false) 
{
    if (twitListingNum == undefined) {
        alert('logical-error : undefined catchTwitList()');
        return false;
    }
    if(twitListingNum < 1) {
        alert('logical-error : (twitListingNum < 1)');
        return false;
    }

    //-----
    //-----
    if(__now_get_twit_list_ing__ == true) {
        return; // 트윗목록을 다운로드 중이면 다음 루프까지 기다린다.
    }
    __now_get_twit_list_ing__ = true; // 트윗목록을 다운로드 중이라고 알린다.

    //-----
    //-----
    var twit_from_latest = from_latest;
    var view_last_id = document.getElementById('view_last_id');
    var view_latest_id = document.getElementById('view_latest_id');

    var tablename = composedbtable_from_date_worker();
    if(tablename.length < 1) {
        alert('error : (no tablename)');
        return false;
    }

    //
    var since_id = '';
    var max_id = '';
    var last_id = view_last_id.value;
    var latest_id = view_latest_id.value;

    if(from_latest == true) { // 최신 트윗 갱신
        since_id = latest_id;
    }
    else { // 맨끝 트윗 갱신
        max_id = last_id;
    }


    //-----
    //-----
    //-twit_timeline_timetable = []; // array 

    //-----
    var result_msg;
    var tpx_command = __twit_command_get_timeline__;

    //----- 
    //----- 
    var tpx_tablename = '&table' + '=' + tablename;
    var tpx_twit_id_max = '&max_id' + '=' + max_id;
    var tpx_twit_since_id = '&since_id' + '=' + since_id;
    var tpx_twit_list_num = '&listnum' + '=' + twitListingNum;
    var tpx_from_latest = '&from_latest' + '=' + twit_from_latest;
   

    var newData = 'action=' + tpx_command + 
            tpx_tablename + 
            tpx_twit_id_max + 
            tpx_twit_since_id + 
            tpx_from_latest + 
            tpx_twit_list_num;
    //--- console.log(newData);

    //-----    
    //-----
    var xhttp;
    var command = processing_command;
    xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (xhttp.readyState == 4 && xhttp.status == 200) {
            //--- console.log(xhttp.responseText + '\r\n');
            var responseTwit = xhttp.responseText.split(__twit_result_sect_delimiter);
            //--- console.log(responseTwit);

            var isAlready;
            var Response_TwitNum = 0;
           
            var Response_LastID = '';
            var Response_Last_Time = '';
            var Response_LatestID = '';
            var Response_Latest_Time = '';

            var time_first = '', time_last = '';
            var transTwitList_Result = {twitNum: 0, last_id:'',  last_id_time:'', latest_id:'',  latest_id_time:'', time_latest:'', time_last:''};
        
            var twit_read_count = document.getElementById('tweet_read_count');
            var read_cnt = 0;
            if(twit_read_count != null) {
                if(twit_read_count.value.length > 0) {
                    read_cnt = parseInt(twit_read_count.value);
                }
            }
    
            for (var i = 0; i < responseTwit.length; i++) {
                isAlready = responseTwit[i].indexOf(__dsm_result_state_error__);
                if (isAlready >= 0) {
                    isAlready = responseTwit[i].indexOf(__twit_result_error_rate_limit_exceed__); // twit-rata-limit-exceed
                    if(isAlready >= 0) {
                        //-timer_sleep_double_restart(__twit_working_sleep_double__); // 대기시간을 2배로 늘린다.
                        result_msg = dsm_working_ing;
                    }
                    else {
                        stopTwitList(from_latest);
                        result_msg = dsm_working_error;
                        console.log(xhttp.responseText + '\r\n');
                        
                        alert(dsm_working_error);
                        alert(xhttp.responseText);

                        // 읽은 것이 없어도 사용자 UI를 위해서 목록출력을 불러줘야 한다.
                        updateTwitListHtml(read_cnt, from_latest);
                        updateTwitTrendList();
                        select_twitlist_menu();

                        // (지정일) 읽은 것이 없으면 날짜별 목록을 보여준다.
                        //-catchTwitDayList();
                        ShowDayList();
                    }
                    break;
                }
                isAlready = responseTwit[i].indexOf(__twit_result_state_twit_num__);
                if (isAlready >= 0) {
                    Response_TwitNum = getPairKeyValue(responseTwit[i], __twit_result_state_twit_num__);
                    //--- alert(Response_TwitNum);
                    result_msg = dsm_working_ing;
                    continue;
                }
                isAlready = responseTwit[i].indexOf(__twit_result_state_twit_list__);
                if (isAlready >= 0) {
                    //-timer_stop_wordlist(); // finish: stop-timer
                    var TwitListReponse = getPairKeyValue(responseTwit[i], __twit_result_state_twit_list__);
                    if (TwitListReponse.length <= 0) {
                        // 오류가 아니라 내용이 없는 경우
                        result_msg = TwitListReponse;
                    } else { // 내용이 있는 경우
                        var twit_FirstAndLast = transTwitListFromTwitReponse(TwitListReponse, transTwitList_Result);
                        if (transTwitList_Result.twitNum <= 0) { // [wordlist]값이 없는 경우인데, 논리적인 오류일 때만 발생한다.
                            console.log('no twit');
                            result_msg = dsm_result_no;
                        } else {
                            //----------
                            //----------
                            Response_LastID = transTwitList_Result.last_id; // 다음에 읽을 수 있도록 맨끝 트윗의 id
                            Response_Last_Time = transTwitList_Result.last_id_time;

                            Response_LatestID = transTwitList_Result.latest_id;
                            Response_Latest_Time = transTwitList_Result.latest_id_time;

                            time_first = transTwitList_Result.time_latest; // first-item
                            time_last = transTwitList_Result.time_last; // last-item

                            updateTwitListHtml(read_cnt, from_latest);
                            updateTwitTrendList();
                            select_twitlist_menu();
                        }
                    }
                    //-----
                    // next-count-set
                    //-----
                    var twit_loop_count = document.getElementById('tweet_loop_count');
                    var twit_time_first = document.getElementById('tweet_time_first');
                    var twit_time_last = document.getElementById('tweet_time_last');
                                        
                    //--- limit-check
                    var loop_count = 0;
                    if(twit_loop_count != null) {
                        if(twit_loop_count.value.length > 0) {
                            loop_count = parseInt(twit_loop_count.value);
                        }
                    }

                    loop_count++;
                    read_cnt += transTwitList_Result.twitNum;
                    set_ById_info(transTwitList_Result.twitNum, 'read_unit');

                    // debug-control
                    if (transTwitList_Result.twitNum <= 0) {
                        // [wordlist]값이 없는 경우인데, 논리적인 오류이거나 트윗서버에 안 줄 때만 발생한다.
                        console.log('no twit' + '\r\n');
                        console.log(xhttp.responseText + '\r\n');
                        result_msg = dsm_result_no;
                    }

                    //-----
                    // display-current-state
                    //-----
                    if(time_first.length > 0) {
                        if((twit_time_first == null) || (twit_time_first.value.length <= 0)) { // 최신 트윗 시각 기록이 없으면 넣어준다.
                            //-set_tweet_time_first(time_first);
                        }
                    }
                    if(time_last.length > 0) {
                        if(twit_time_last != null) { // 최종 트윗 시각 기록을 갱신한다.
                            //-set_tweet_time_last(time_last);
                        }
                    }
                    set_ById_info(loop_count, 'tweet_loop_count');
                    set_ById_info(read_cnt, 'tweet_read_count');
                    //-set_ById_info(twit_timeline_list_worker.length, 'total_read_count');
                    update_total_read_count(twit_timeline_list_worker.length);

                    //-----
                    //-----
                    set_ById_info(Response_LastID, 'tweet_last_id');
                    set_ById_info_time(Response_Last_Time, 'tweet_last_id_time');

                    set_ById_info(Response_LatestID, 'tweet_latest_id');
                    set_ById_info_time(Response_Latest_Time, 'tweet_latest_id_time');
                    
                    //-----
                    // update - last & latest
                    //-----
                    if(transTwitList_Result.twitNum <= 0) { 
                        // 읽은 것이 없는 경우 - 둘 중에 하나, 트윗서버 지연이거나 트윗서버로부터 가장 최신까지 읽고나서 더 이상 트윗이 없는 경우
                        // ===> 계속해서 새 트윗을 읽는 것이므로 아무것도 하지 않는다.
                        //      {since_id}값을 바꾸거나 지워버리면 다음에 읽어야할 위치를 모르기 때문에 
                        //      (가져오려는 시점)현재부터 20개(지정한 개수)를 읽어버리면 
                        //      이미 읽었던 것을 또 읽어와서 (저장할 경우에는) 저장하라고 보내게 된다.
                        //      (물론 저장 모듈에서도 중복 검사를 하지만 논리적으로 깔끔하지 않은 것은 막는다.)
                    }
                    else {
                        update_view_last_id_info(Response_LastID, Response_Last_Time);
                        update_view_latest_id_info(Response_LatestID, Response_Latest_Time);
                    }

                    //-----
                    //-break; 
                    //-----
                    // 여기서 브레이크를 걸지 않는다.
                    // - 논리적으로 트윗 목록 다음에 에러-메시지가 오는 경우가 있어서 그럴 경우를 위해서 다음으로 가도록 넘겨준다.
                    continue;
                }
                isAlready = responseTwit[i].indexOf(__twit_mysql_error_msg_undefine_var__);
                if (isAlready >= 0) { // mysql-undefined-variable
                    stopTwitList(from_latest);
                    alert(__twit_mysql_error_msg_undefine_var__);
                    result_msg = dsm_working_error;
                    console.log(xhttp.responseText + '\r\n');
                    break;
                }
                isAlready = responseTwit[i].indexOf(__twit_mysql_error_msg_catchable_fatal__);
                if (isAlready >= 0) { // mysql-undefined-variable
                    stopTwitList(from_latest);
                    alert(__twit_mysql_error_msg_catchable_fatal__);
                    result_msg = dsm_working_error;
                    console.log(xhttp.responseText + '\r\n');
                    break;
                }
                isAlready = responseTwit[i].indexOf(__twit_mysql_error_msg_connect__);
                if (isAlready >= 0) { // mysql-undefined-variable
                    stopTwitList(from_latest);
                    alert(__twit_mysql_error_msg_connect__);
                    result_msg = dsm_working_error;
                    console.log(xhttp.responseText + '\r\n');
                    break;
                }                
            }
            if (responseTwit.length <= 0) {
                result_msg = dsm_result_no;
            }
            else {
            }
            //-----
            CheckWorkEnd(from_latest);
            if(isCompleteDownload() == true) {
                stopTwitList(from_latest);
                alert('complete : download twit-list');
            }
``
            //---
            // timer-control
            if (tweet_timer_id != 0) { // 타이머가 활동 중
                //-if(transTwitList_Result.twitNum < twit_read_num_half.value) { // 읽으라는 [개수의 반]도 못 읽은 경우 - 읽을 것이 몇 개 안 됨.
                //-    timer_sleep_double_restart('few read twit-msg, time-gab double'); // 대기시간을 2배로 늘린다.
                //-}
                //-else {
                //-    if (transTwitList_Result.twitNum > 0) {// 절반보다 많이 읽었으면 타이머 간격을 좁혀준다.
                //-        timer_sleep_half_restart(); // 대기 시간을 1/2ㄹ 줄인다.
                //-    }
                //-}
                worker_time_gage = null; // 트윗 가져오기 호출이 끝났으므로 간격조절 시각을 초기화
            }

            //-----
            //-----
            __now_get_twit_list_ing__ = false; // 트윗목록을 다운로드가 끝났다고 알린다.
        }
    };
    //-xhttp.open('GET', command+newData, true);
    //-xhttp.send();   

    xhttp.open('POST', command, true);
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhttp.send(newData);

    //
    return true;
}

function transTwitListFromTwitReponse(TwitListSeries, transTwitList_Result)
{
    // twit_timeline_list_worker 변수를 초기화하기 전에 마지막 트윗항목을 받아둔다.
    var twit_FirstAndLast = getTwitList_TwitItem_Limit(twit_FirstAndLast);
    
    // init-reset
    twit_timeline_list_worker = []; // array 

    // init
    transTwitList_Result.twitNum = 0;
    
    //
    var TwitList_Array = TwitListSeries.split(__twit_result_state_twit_line__);
    var findPos;
    var twit_last_id = '';
    var rwit_last_id_time = '';
    var twit_cnt = 0;
    var twit_first = false;
    for (twit_cnt = 0; twit_cnt < TwitList_Array.length; twit_cnt++) {
        if (TwitList_Array[twit_cnt].length == 0) { // __twit_result_state_twit_line__ 있고 내용이 없는 경우 - 맨 뒤에 추가 붙는 것이 있다.
            continue;
        }
        var oneTwit = TwitList_Array[twit_cnt];
        oneTwit = oneTwit.trim();
        if (oneTwit.length <= 0) {
            continue;
        }

        //
        var TwitFieldList = oneTwit.split(__twit_result_field_delimiter);
        if (TwitFieldList.length <= 1) {
            continue;
        }

        var rec_id = 0;
        var twit_order = 0, twit_id = 0, twit_user_id = 0;
        var twit_user_name = '';
        var twit_screen_name = '';
        var twit_text = '';
        var twit_time = '';
        var twit_urlencoded = '';
        var urlencoded_state;
        for (var field_cnt = 0; field_cnt < TwitFieldList.length; field_cnt++) {
            var TwitField = TwitFieldList[field_cnt];
            TwitField = TwitField.trim();
            if (TwitField.length <= 0) {
                continue;
            }

            //
            findPos = TwitField.indexOf(__twit_result_state_twit_order__);
            if(findPos >= 0) {
                twit_order = getPairKeyValue(TwitField, __twit_result_state_twit_order__);
            }
            findPos = TwitField.indexOf(__twit_result_state_rec_id__);
            if(findPos >= 0) {
                rec_id = getPairKeyValue(TwitField, __twit_result_state_rec_id__);
            }
            findPos = TwitField.indexOf(__twit_result_state_twit_id__);
            if(findPos >= 0) {
                twit_id = getPairKeyValue(TwitField, __twit_result_state_twit_id__);
            }
            findPos = TwitField.indexOf(__twit_result_state_twit_user_id__);
            if(findPos >= 0) {
                twit_user_id = getPairKeyValue(TwitField, __twit_result_state_twit_user_id__);
            }
            findPos = TwitField.indexOf(__twit_result_state_twit_user_name__);
            if(findPos >= 0) {
                twit_user_name = getPairKeyValue(TwitField, __twit_result_state_twit_user_name__);
            }
            findPos = TwitField.indexOf(__twit_result_state_twit_screen_name__);
            if(findPos >= 0) {
                twit_screen_name = getPairKeyValue(TwitField, __twit_result_state_twit_screen_name__);
            }
            findPos = TwitField.indexOf(__twit_result_state_twit_text__);
            if(findPos >= 0) {
                twit_text = getPairKeyValue(TwitField, __twit_result_state_twit_text__);
            }
            findPos = TwitField.indexOf(__twit_result_state_twit_time__);
            if(findPos >= 0) {
                twit_time = getPairKeyValue(TwitField, __twit_result_state_twit_time__);
            }
            findPos = TwitField.indexOf(__twit_result_state_twit_urlencoded__);
            if(findPos >= 0) {
                twit_urlencoded = getPairKeyValue(TwitField, __twit_result_state_twit_urlencoded__);
            }
        }
        
        // urlencoded-check
        urlencoded_state = false;
        if(twit_urlencoded.length > 0) {
            if((twit_urlencoded == true) || (twit_urlencoded == 1) || (twit_urlencoded.string_a.localeCompare('1') == 0) || 
            (twit_urlencoded.string_a.localeCompare('true') == 0) || (twit_urlencoded.string_a.localeCompare('TRUE') == 0)) {
                urlencoded_state = true;
            }
        }

        //
        transTwitList_Result.twitNum++;

        //-----
        //-----
        var twitItem = { order:     twit_order, 
                        rec_id:     rec_id,
                        twit_id:    twit_id, 
                        user_id:    twit_user_id, 
                        user_name:  twit_user_name, 
                        screen_name:twit_screen_name, 
                        text:       twit_text, 
                        time:       twit_time,
                        urlencoded: urlencoded_state
                        };
        twit_timeline_list_worker.push(twitItem);
        
        var twitItem_4_all = twitItem;
        twit_timeline_list_all.push(twitItem_4_all);

        //-----
        //-----
        if(twit_first == false) {
            twit_first = true;
            update_twit_date_worker(twit_time);
        }

        //-----
        //-----
        twit_last_id = twit_id;
        rwit_last_id_time = twit_time;
        if(transTwitList_Result.time_latest.length <= 0) {
            transTwitList_Result.time_latest = twit_time;
        }
        transTwitList_Result.time_last = twit_time;

        if(transTwitList_Result.latest_id.length <= 0) {
            transTwitList_Result.latest_id = twit_id;
            transTwitList_Result.latest_id_time = twit_time;
        }
    }

    // parameter-control
    transTwitList_Result.last_id = twit_last_id;
    transTwitList_Result.last_id_time = rwit_last_id_time;

    // time-old-new-check
    var time_reverse_flag = false;
    if(transTwitList_Result.latest_id.localeCompare(transTwitList_Result.last_id) < 0) {
        // 맨 앞 것이 맨 뒤 것보다 시간적으로 옛날인 경우
        var saveValue = transTwitList_Result.latest_id;
        transTwitList_Result.latest_id = transTwitList_Result.last_id;
        transTwitList_Result.last_id = saveValue;

        saveValue = transTwitList_Result.latest_id_time;
        transTwitList_Result.latest_id_time = transTwitList_Result.last_id_time;
        transTwitList_Result.last_id_time = saveValue;

        //
        time_reverse_flag = true;
    }
    if(time_reverse_flag == true) {
        // 서버로부터 받은 트윗 목록이 {오래된 것}부터 {최신 것}으로 된 것이면 
        // 순서를 반대로 바꿔준다. 이 함수 밖에서는 항상 [최신->옛날] 트윗 순서대로 처리한다.
        var twit_timeline_reverse = []; // array 
        for (twit_cnt = (twit_timeline_list_worker.length - 1); twit_cnt >= 0; twit_cnt--) {
            var twitItem = twit_timeline_list_worker[twit_cnt];
            twit_timeline_reverse.push(twitItem);
        }        
        twit_timeline_list_worker = twit_timeline_reverse;
    }

    //
    return twit_FirstAndLast; // 이전에 맨 처음과 맨 마지막 트윗항목을 돌려준다.
}

function CheckWorkEnd(from_latest = false) 
{
    //-----
    //-----
    var tweet_loop_count = document.getElementById('tweet_loop_count');
    var tweet_loop_max = document.getElementById('tweet_loop_max');
    var twit_read_count = document.getElementById('tweet_read_count');
    var twit_read_max = document.getElementById('tweet_read_max');
    
    //--- timer-check
    var read_cnt = 0;
    var read_max = 0;
    if(twit_read_count != null) {
        if(twit_read_count.value.length > 0) {
            read_cnt = parseInt(twit_read_count.value);
        }
    }
    if(twit_read_max != null) {
        if(twit_read_max.value.length > 0) {
            read_max = parseInt(twit_read_max.value);
        }
    }
    if((read_max > 0) && // read_max: '1' 보다 작으면 무제한
        (read_cnt > 0)) {
        if (read_cnt >= read_max) {
            stopTwitList(from_latest);
            alert('work end');
            return true;
        }
    }
    var loop_count = parseInt(tweet_loop_count.value);
    var loop_max = parseInt(tweet_loop_max.value);
    if ((loop_max > 0) &&  // loop_max: '1' 보다 작으면 무제한
        (loop_count > 0)) {
        if (loop_count >= loop_max) {
            stopTwitList(from_latest);
            alert('work end');
            return true;
        }
    }

    //
    return false;
}

function composedbtable_from_date_worker(timetable_mode = false, twit_time = '')
{
    var tablename = '';

    var var_tablename = document.getElementById('sys_info_tablename').value;
    if(var_tablename.length < 1) {
        return tablename;
    }
    
    var tweet_date_worker = get_tweet_date_worker(twit_time);

    //---
    tablename = var_tablename + '_' + tweet_date_worker;

    //---
    if(timetable_mode == true) {
        tablename += klip_table_timetable_adder;
    }

    //---
    return tablename;
}

function get_tweet_date_worker(twit_time = '')
{
    var timetable_date = '';
    
    //
    var typeof_time = (typeof twit_time === 'object');
    if(typeof_time == false) {
        typeof_time = (typeof twit_time === 'string');
        if(typeof_time == true) {
            if(twit_time.length < 1) { // 문자열이면 길이를 검사하여 없으면 지정한 시간이 없다는 뜻
                typeof_time = false;
            }
        }        
    }
    if(typeof_time == true) { // 지정된 시간이 있으면 사용한다.
        //
        var twit_time_date = new Date(twit_time);

        //
        var twit_time_date_month = String((twit_time_date.getMonth() + 1));
        var twit_time_date_day =  String(twit_time_date.getDate());

        var twit_time_date_format =  String(twit_time_date.getFullYear());

        if(twit_time_date_month.length <= 1) {
            twit_time_date_format += '0';
        }
        twit_time_date_format += twit_time_date_month;

        if(twit_time_date_day.length <= 1) {
            twit_time_date_format += '0';
        }
        twit_time_date_format += twit_time_date_day;

        //---
        timetable_date = twit_time_date_format;
    }
    else {
        // 
        //-var tweet_date_worker_year = document.getElementById('tweet_date_worker_year').value;
        //-var tweet_date_worker_month = document.getElementById('tweet_date_worker_month').value;
        //-var tweet_date_worker_day = document.getElementById('tweet_date_worker_day').value;

        var working_day = new Date(); // 현재 시각

        // 사용자 지정 날짜가 있으면 그것을 사용한다.
        var tweet_date_client = document.getElementById('tweet_date_client').value; // 사용자 지정 날짜
        tweet_date_client = String(tweet_date_client);
        if(tweet_date_client.length == 8) {
            var date_worker_year = tweet_date_client.slice(0, 4);
            var date_worker_month = tweet_date_client.slice(4, 6);
            var date_worker_day = tweet_date_client.slice(6, 8);
            
            //
            var working_day_format = date_worker_year + '-' + date_worker_month + '-' + date_worker_day;
            var working_day = new Date(working_day_format);
        }

        var tweet_date_worker_year = working_day.getFullYear();
        var tweet_date_worker_month = (working_day.getMonth() + 1);
        var tweet_date_worker_day = working_day. getDate();

        //
        tweet_date_worker_year = String(tweet_date_worker_year);
        tweet_date_worker_month = String(tweet_date_worker_month);
        tweet_date_worker_day = String(tweet_date_worker_day);
    
        //
        if(tweet_date_worker_year.length != 4) {
            return timetable_date;
        }
        if((tweet_date_worker_month.length < 1) || (tweet_date_worker_month.length > 2)) {
            return timetable_date;
        }
        if((tweet_date_worker_day.length < 1) || (tweet_date_worker_day.length > 2)) {
            return timetable_date;
        }
    
        //
        timetable_date = tweet_date_worker_year;
    
        if(tweet_date_worker_month.length != 2) {
            timetable_date += '0';
        }
        timetable_date += tweet_date_worker_month;
    
        if(tweet_date_worker_day.length != 2) {
            timetable_date += '0';
        }
        timetable_date += tweet_date_worker_day;
    }

    //
    return timetable_date;
}

function refreshViewerPage() 
{
    // 파이어폭스에서는 페이지를 reload 해도 값이 남아 있다.
    // 그래서 관련 변수를 직접 초기화해준다.
    document.getElementById('tweet_loop_count').value = '';
    document.getElementById('tweet_read_count').value = '';
    document.getElementById('tweet_last_id').value = '';
    document.getElementById('tweet_last_id_time').value = '';
    document.getElementById('tweet_latest_id').value = '';
    document.getElementById('tweet_latest_id_time').value = '';

    //---    
    reloadPage();
}

function getTwitList_TwitItem_Limit(twit_FirstAndLast)
{   // 시간상 맨 처음과 맨 나중 것을 찾아서 반환한다.
    //
    var twit_FirstAndLast = [];
    twit_FirstAndLast['first'] = '';
    twit_FirstAndLast['last'] = '';

    //-// init-reset
    //-twit_timeline_list_worker = []; // array
    if(twit_timeline_list_worker.length < 1) {
        return twit_FirstAndLast;
    }

    //---
    if(twit_timeline_list_worker.length == 1) {
        //-twit_timeline_list_worker[0];
    }

    //---
    var twitItem_First = twit_timeline_list_worker[0];
    var twitItem_Last = twit_timeline_list_worker[twit_timeline_list_worker.length - 1];

    //-----
    //-----
    //-var twitItem = { order:     twit_order, 
    //-    rec_id:     rec_id,
    //-    twit_id:    twit_id, 
    //-    user_id:    twit_user_id, 
    //-    user_name:  twit_user_name, 
    //-    screen_name:twit_screen_name, 
    //-    text:       twit_text, 
    //-    time:       twit_time,
    //-    urlencoded: urlencoded_state
    //-    };

    // time-old-new-check
    if(typeof twitItem_First.twit_id === 'string') {
        if(twitItem_First.twit_id.localeCompare(twitItem_Last.twit_id) < 0) {
            // 맨 앞 것이 맨 뒤 것보다 시간적으로 옛날인 경우
            //-twitItem_Last;
        }
        else {
            var tmpSave = twitItem_First; // real-last
            twitItem_First = twitItem_Last;
            twitItem_Last = tmpSave;
        }
    }
    else if(typeof twitItem_First.twit_id === 'number') {
        if(twitItem_First.twit_id < twitItem_Last.twit_id) {
            // 맨 앞 것이 맨 뒤 것보다 시간적으로 옛날인 경우
            //-return twitItem_Last;
        }
        else {
            var tmpSave = twitItem_First; // real-last
            twitItem_First = twitItem_Last;
            twitItem_Last = tmpSave;
        }
    }
    else {
        alert(' error : (typeof twitItem_First.twit_id)');
        return twit_FirstAndLast;
    }

    //
    twit_FirstAndLast['first'] = twitItem_First;
    twit_FirstAndLast['last'] = twitItem_Last;

    return twit_FirstAndLast;    
}

function update_tweet_last_id_info(last_id, last_id_time)
{   
    var old_view_last_id = document.getElementById('tweet_last_id').value;
    var new_view_last_id = '';

    if((old_view_last_id == null) || (old_view_last_id.length <= 0)) {
        new_view_last_id = last_id;
    }
    else {
        if(compareTwitID(old_view_last_id,last_id) > 0) {
            new_view_last_id = last_id;
        }
    }
    if(new_view_last_id.length > 0) {
        set_ById_info(last_id, 'tweet_last_id');
        set_ById_info_time(last_id_time, 'tweet_last_id_time');
    }
}

function update_tweet_latest_id_info(latest_id, latest_id_time)
{   
    var old_view_latest_id = document.getElementById('tweet_latest_id').value;

    var new_view_latest_id = '';

    if((old_view_latest_id == null) || (old_view_latest_id.length <= 0)) {
        new_view_latest_id = latest_id;
    }
    else {
        if(compareTwitID(old_view_latest_id,latest_id) < 0) {
            new_view_latest_id = latest_id;
        }
    }
    if(new_view_latest_id.length > 0) {
        set_ById_info(latest_id, 'tweet_latest_id');
        set_ById_info_time(latest_id_time, 'tweet_latest_id_time');
    }
}

function update_view_last_id_info(last_id, last_id_time)
{   
    var old_view_last_id = document.getElementById('view_last_id').value;
    var new_view_last_id = '';

    if((old_view_last_id == null) || (old_view_last_id.length <= 0)) {
        new_view_last_id = last_id;
    }
    else {
        if(compareTwitID(old_view_last_id,last_id) > 0) {
            new_view_last_id = last_id;
        }
    }
    if(new_view_last_id.length > 0) {
        set_ById_info(last_id, 'view_last_id');
        set_ById_info_time(last_id_time, 'view_last_id_time');
    }
}

function update_view_latest_id_info(latest_id, latest_id_time)
{   
    var old_view_latest_id = document.getElementById('view_latest_id').value;

    var new_view_latest_id = '';

    if((old_view_latest_id == null) || (old_view_latest_id.length <= 0)) {
        new_view_latest_id = latest_id;
    }
    else {
        if(compareTwitID(old_view_latest_id,latest_id) < 0) {
            new_view_latest_id = latest_id;
        }
    }
    if(new_view_latest_id.length > 0) {
        set_ById_info(latest_id, 'view_latest_id');
        set_ById_info_time(latest_id_time, 'view_latest_id_time');
    }
}

function update_total_read_count(new_read_count)
{   
    var old_total_read_count = document.getElementById('total_read_count').value;
    old_total_read_count = parseInt(old_total_read_count);
    if(old_total_read_count < 0) {
        old_total_read_count = 0;
    }

    var new_total_read_count = parseInt(new_read_count);
    //-----
    // '0'보다 작은 값도 올 수 있다.
    //-----
    //-if(new_total_read_count < 0) {
    //-    new_total_read_count = 0;
    //-}
    //-----

    old_total_read_count += new_total_read_count;
    set_ById_info(old_total_read_count, 'total_read_count');
}

function showTwitTable_TwitID()
{
    var lastest_flag = true; // 최신(늦은)
    if(getTwitTable_TwitID(lastest_flag) == false) {
        return false;
    }
    var lastest_flag = false;
    if(getTwitTable_TwitID(lastest_flag) == false) {
        return false;
    }

    //
    return true;
}

function getTwitTable_TwitID(lastest_flag = true)
{
    var twit_table_name_worker = composedbtable_from_date_worker();
    if(twit_table_name_worker.length < 1) {
        alert('error: (twit_table_name_worker == null)');
        return ;
    }

    //-----
    var result_msg;
    var tpx_command = __twit_command_twit_id_latest__; // 최신값으로 
    if(lastest_flag != true) {
        tpx_command = __twit_command_twit_id_last__; // 가장 오래된 값으로
    }

    //----- 
    //----- 
    var tpx_dbtable = '&table=' + twit_table_name_worker;

    var newData = 'action=' + tpx_command + 
                tpx_dbtable; 
    //--- console.log(newData);

    //-----    
    //-----
    var xhttp;
    var command = processing_command;
    xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (xhttp.readyState == 4 && xhttp.status == 200) {
            //--- console.log(xhttp.responseText + '\r\n');
            var responseTwit = xhttp.responseText.split(__twit_result_sect_delimiter);
            //--- console.log(responseTwit);

            var isAlready;
            var Response_RecID = '';
            var Response_TwitId = '';
            var Response_TwitId_Time = '';

            for (var i = 0; i < responseTwit.length; i++) {
                isAlready = responseTwit[i].indexOf(__dsm_result_state_error__);
                if (isAlready >= 0) {
                    result_msg = dsm_working_error;
                    console.log(xhttp.responseText + '\r\n'); // db-table없는 상태에서 twitID를 구하다보면 이렇게도 오는데 반드시 오류는 아님
                    console.log('db-table이 없을 경우에는 오류라도 계속 진행해도 됩니다.');
                    break;
                }
                isAlready = responseTwit[i].indexOf(__dsm_result_state_rec__);
                if (isAlready >= 0) {
                    Response_RecID = getPairKeyValue(responseTwit[i], __dsm_result_state_rec__);
                    //--- alert(Response_RecID);
                    result_msg = dsm_working_ing;
                }
                isAlready = responseTwit[i].indexOf(__twit_result_state_twit_id__);
                if (isAlready >= 0) {
                    Response_TwitId = getPairKeyValue(responseTwit[i], __twit_result_state_twit_id__);
                    //--- alert(Response_TwitId);
                    result_msg = dsm_working_ing;

                    //-----
                    // display-current-state
                    //-----
                    if(lastest_flag == true) {
                        //-set_tweet_table_end_id(Response_TwitId);
                        set_ById_info(Response_TwitId, 'tweet_table_end_id');
                    }
                    else {
                        //-set_tweet_table_begin_id(Response_TwitId);
                        set_ById_info(Response_TwitId, 'tweet_table_begin_id');
                    }
                }
                isAlready = responseTwit[i].indexOf(__twit_result_state_twit_time__);
                if (isAlready >= 0) {
                    Response_TwitId_Time = getPairKeyValue(responseTwit[i], __twit_result_state_twit_time__);
                    //--- alert(Response_TwitId_Time);
                    result_msg = dsm_working_ing;

                    //-----
                    // display-current-state
                    //-----
                    if(lastest_flag == true) {
                        //-set_tweet_table_end_id_time(Response_TwitId_Time);
                        set_ById_info_time(Response_TwitId_Time, 'tweet_table_end_id_time');
                    }
                    else {
                        //-set_tweet_table_begin_id_time(Response_TwitId_Time);
                        set_ById_info_time(Response_TwitId_Time, 'tweet_table_begin_id_time');
                    }
                }
            }
            if (responseTwit.length <= 0) {
                result_msg = dsm_result_no;
            }
        }
    };
    //-xhttp.open('GET', command+newData, true);
    //-xhttp.send();   

    xhttp.open('POST', command, true);
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhttp.send(newData);

    //
    return true;
}

function update_tweet_table_name_working()
{   
    var tweet_table_name_working = composedbtable_from_date_worker();
    if(tweet_table_name_working.length > 0) {
        var color_string = '<font color=blue>' + tweet_table_name_working + '</font>';
        tweet_table_name_working = color_string;
    }
    set_ById_info(tweet_table_name_working, 'tweet_table_name_working');
}

function getTwitTable_RecNum()
{
    var twit_table_name_worker = composedbtable_from_date_worker();
    if(twit_table_name_worker.length < 1) {
        alert('error: (twit_table_name_worker == null)');
        return ;
    }

    //-----
    var result_msg;
    var tpx_command = __twit_command_get_rec_num__;

    //----- 
    //----- 
    var tpx_dbtable = '&table=' + twit_table_name_worker;

    var newData = 'action=' + tpx_command + 
                tpx_dbtable; 
    //--- console.log(newData);

    //-----    
    //-----
    var xhttp;
    var command = processing_command;
    xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (xhttp.readyState == 4 && xhttp.status == 200) {
            //--- console.log(xhttp.responseText + '\r\n');
            var responseTwit = xhttp.responseText.split(__twit_result_sect_delimiter);
            //--- console.log(responseTwit);

            var isAlready;
            var Response_RecNum = '';

            for (var i = 0; i < responseTwit.length; i++) {
                isAlready = responseTwit[i].indexOf(__dsm_result_state_error__);
                if (isAlready >= 0) {
                    result_msg = dsm_working_error;
                    console.log(xhttp.responseText + '\r\n'); // db-table없는 상태에서 twitID를 구하다보면 이렇게도 오는데 반드시 오류는 아님
                    console.log('db-table이 없을 경우에는 오류라도 계속 진행해도 됩니다.');
                    break;
                }
                isAlready = responseTwit[i].indexOf(__dsm_result_state_recnum__);
                if (isAlready >= 0) {
                    Response_RecNum = getPairKeyValue(responseTwit[i], __dsm_result_state_recnum__);
                    //--- alert(Response_RecNum);
                    result_msg = dsm_working_ing;

                    //-----
                    // display-current-state
                    //-----
                    set_ById_info(Response_RecNum, 'total_rec_count');
                }
            }
            if (responseTwit.length <= 0) {
                result_msg = dsm_result_no;
            }
        }
    };
    //-xhttp.open('GET', command+newData, true);
    //-xhttp.send();   

    xhttp.open('POST', command, true);
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhttp.send(newData);

    //
    return true;
}

function showTwitDBTable_Info()
{
    update_tweet_table_name_working();
    update_twit_date_worker();

    getTwitTable_RecNum();
    showTwitTable_TwitID();
}

function update_twit_date_worker(twit_time = '')
{
    var tweet_date_worker = get_tweet_date_worker(twit_time);
    
    set_ById_info(tweet_date_worker, 'tweet_date_worker');
}

function update_twitlist(latest_flag = true)
{
    //-----
    // 이 함수는 자동으로 받기 위한 것이므로 받는 위치(최종/최신)를 조정해야 한다.
    // 현재 동작하는 날짜와 작업 날짜(tweet_date_worker/tweet_date_client)가 다르면 
    // 최신(latest_flag = true) 것을 받지말고 최종(last) 트윗부터 과거 트윗을 받는다.
    //-----
    var id_tweet_date_worker_boot = document.getElementById('disp_tweet_date_worker_boot');
    //-var id_tweet_date_worker = document.getElementById('disp_tweet_date_worker');
    var id_tweet_date_client = document.getElementById('disp_tweet_date_client');
    var string_tweet_date_worker_boot = String(id_tweet_date_worker_boot.innerText);
    var string_tweet_date_client = String(id_tweet_date_client.innerText);
    if(string_tweet_date_worker_boot.localeCompare(string_tweet_date_client) != 0) {
        latest_flag = false;
    }

    //-----
    //-----
    if(tweet_timer_id != 0) { // timer 동작 중이면 작업을 종료한다.
        stopTwitList(latest_flag);
        return true;
    }
    //-----
    //-----
    blocking_TwitListButton(true);

    //-----
    // work-begin
    //-----
    //-document.getElementById('label_twitlist_update_latest').value = 'Stop';
    //-document.getElementById('label_twitlist_update_latest').innerHTML = 'Stop';

    // 홈페이지에서 기다리는 중간에 (리프레시 없이) [?]버튼을 또 다시 누르면 타이머가 2개 이상 동작하게 된다.
    // 그래서 [?]버튼을 누르면 무조건 타이머를 꺼야 한다.
    timer_stop_twitlist();

    //---
    if(getTwitList(latest_flag) == false) {
        stopTwitList(latest_flag);
        return false;
    }
    timer_start_twitlist(latest_flag);
}

function stopTwitList(latest_flag = false)
{
    //-----
    //-----
    timer_stop_twitlist();
    //-document.getElementById('label_twitlist_update_latest').value = '자동';
    //-document.getElementById('label_twitlist_update_latest').innerHTML = '자동';

    if(latest_flag == true) { // 최신 것을 받는 경우
        var btn_twitlist_update_latest = document.getElementById('btn_twitlist_update_latest');
        if(btn_twitlist_update_latest.checked) { // 자동으로 [최신] 받고 있으면 버튼을 해제한다.
            btn_twitlist_update_latest.checked = false;
        }        
    }
    else { // 과거 것을 받는 경우
        var btn_twitlist_update_last = document.getElementById('btn_twitlist_update_last');
        if(btn_twitlist_update_last.checked) { // 자동으로 [과거] 받고 있으면 버튼을 해제한다.
            btn_twitlist_update_last.checked = false;
        }        
    }
    
    //-----
    //-----
    blocking_TwitListButton(false);
}

function blocking_TwitListButton(blockingFlag = false) 
{
    //-----
    // 목록을 가져오는 동안 바뀌면 안 되는 컨트롤을 잠가두거나 풀어준다.
    //-----
    document.getElementById('btn_listing_num').disabled = blockingFlag;
}

function timer_stop_twitlist() 
{
    //---
    if (tweet_timer_id != 0) {
        clearInterval(tweet_timer_id); // finish: stop-timer
    }
    tweet_timer_id = 0;

    //---
    if (twit_timer_gage_id != 0) {
        clearInterval(twit_timer_gage_id); // finish: stop-timer
    }
    twit_timer_gage_id = 0;
    set_ById_info('0', 'time_counter');
}

function timer_start_twitlist(latest_flag = true)
{
    timer_stop_twitlist();

    var twit_sleep_interval_ID = document.getElementById('twitlist_update_interval_option');
    var twit_sleep_interval_js = (twit_sleep_interval_ID.value * 1000); // javascript 초 단위
    tweet_timer_id = setInterval(function() {getTwitList(latest_flag);}, twit_sleep_interval_js);

    set_ById_info(twit_sleep_interval_ID.value, 'time_interval');

    //---
    twit_timer_gage_id = setInterval(UpdateTimerGage, twit_timer_gage_interval);
    worker_time_gage = new Date();
}

function UpdateTimerGage()
{
    var gage_time_current = new Date();
    if(worker_time_gage == null) {
        worker_time_gage = gage_time_current;
    }

    // time difference 
    var timeDiff = gage_time_current - worker_time_gage;
    // strip the ms
    var seconds = parseInt(timeDiff / 1000);
    //-// get seconds (Original had 'round' which incorrectly counts 0:28, 0:29, 1:30 ... 1:59, 1:0)
    //-var seconds_round = Math.round(seconds % 60);
    elapse_time_string = '<font color=blue>' + seconds + '</font>';
    set_ById_info(elapse_time_string, 'time_counter');
}

function CountTimeElapse()
{
    var worker_time_current = new Date();
    //-var current_time_string = worker_time_current.toDateString() + ' ' + worker_time_current.toTimeString();
    //-var worker_time_current_string = worker_time_current.toLocaleString();
    var worker_time_current_string = get_tweet_time_string(worker_time_current);

    //-set_ById_info(worker_time_current_string, 'time_current');

    if(worker_time_start == null) {
        worker_time_start = worker_time_current;
        //-set_ById_info(worker_time_current_string, 'time_start');
    }

    // time elapse 
    var elapse_time_string = makeTimeElapseString(worker_time_current, worker_time_start);
    set_ById_info(elapse_time_string, 'time_elapse');
}

function check_dbtable_field()
{
    var var_tablename = document.getElementById('sys_info_tablename').value;
    if(var_tablename.length < 1) {
        return false;
    }
    return true;
}

function show_twit_monitor()
{
    var list_monitor_hidden = true;
    var btn_twitlist_monitor = document.getElementById('btn_twitlist_monitor');
    if((btn_twitlist_monitor != null) &&
        (btn_twitlist_monitor.checked)) {
            list_monitor_hidden = false;
    }

    if(document.getElementById('twit-list-monitor') != null) {
        document.getElementById('twit-list-monitor').hidden = list_monitor_hidden;
        var display_opt = 'block';
        if(list_monitor_hidden == false) { // show
        }
        else {
            display_opt = 'none';
        }
        document.getElementById('twit-list-monitor').style.display = display_opt;
    }

    //
    if(list_monitor_hidden == true) {
        document.getElementById('twitlist_view_timeline_option').disabled = true;
        document.getElementById('twitlist_view_timecycle_option').disabled = true;
    }
    else {
        document.getElementById('twitlist_view_timeline_option').disabled = false;
        document.getElementById('twitlist_view_timecycle_option').disabled = false;

        // 레코드 개수가 없으면 읽어온다.
        var disp_total_rec_count_by = document.getElementById('disp_total_rec_count');
        if(disp_total_rec_count_by != null) {
            var disp_total_rec_count_htm = disp_total_rec_count_by.innerHTML;
            var disp_total_rec_count = 0;
            if(disp_total_rec_count_htm.length > 0) {
                disp_total_rec_count = parseInt(disp_total_rec_count_htm);
            }
            if(disp_total_rec_count <= 0) {
                showTwitDBTable_Info();        
            }
        }
    }
}

function ShowYesterday()
{
    var other_date_worker = get_other_working_date(false);
    
    // 현재 작업날을 다음날로 바꿔준다.
    var day_parameter = MakeYearMonthDay_AddressParameter(other_date_worker);
    var day_address = 'twit_v.php?';
    var day_link = day_address + day_parameter;
    window.open(day_link, '_' + day_parameter);
}

function ShowTomorrow()
{
    var other_date_worker = get_other_working_date(true);
    
    // 현재 작업날을 다음날로 바꿔준다.
    var day_parameter = MakeYearMonthDay_AddressParameter(other_date_worker);
    var day_address = 'twit_v.php?';
    var day_link = day_address + day_parameter;
    window.open(day_link, '_' + day_parameter);
}

function ShowDayList()
{
    var day_parameter = 'daylist=1';
    var day_address = 'twit_v.php?';
    var day_link = day_address + day_parameter;
     window.open(day_link, '_' + day_parameter);
}

function MakeYearMonthDay_Address(date_yyyymmdd)
{
    // 작업날을 바꿔준다.
    var day_address = 'twit_v.php?';
    var day_parameter = MakeYearMonthDay_AddressParameter(date_yyyymmdd);
    var day_link = day_address + day_parameter;
    return day_link;
}

function MakeYearMonthDay_AddressParameter(date_yyyymmdd)
{
    // 
    var day_format_year = date_yyyymmdd.slice(0, 4);
    var day_format_month = date_yyyymmdd.slice(4, 6);
    var day_format_day = date_yyyymmdd.slice(6, 8);

    var day_parameter = 'year=' + day_format_year + '&month=' + day_format_month +  '&day=' + day_format_day;
    return day_parameter;
}

function get_other_working_date(next_day_flag = false)
{   // 현재 작업일을 변경한다.
    //---------------
    //---------------
    var tweet_date_working = '';
    var tweet_date_boot = '';
    var tweet_date_client = document.getElementById('tweet_date_client').value; // 사용자 지정 날짜
    if(tweet_date_client.length == 0) { //
        tweet_date_boot = document.getElementById('tweet_date_worker_boot').value; // 프로그램 동작 순간 날짜
        tweet_date_working = tweet_date_boot;
    }
    else {
        tweet_date_working = tweet_date_client;
    }
    tweet_date_working = String(tweet_date_working);
    if(tweet_date_working.length != 8) { // yyyymmdd(8자리)형식이 아니면 종료
        return false;
    }
    
    //
    var date_worker_year = tweet_date_working.slice(0, 4);
    var date_worker_month = tweet_date_working.slice(4, 6);
    var date_worker_day = tweet_date_working.slice(6, 8);
    
    //
    var working_day_format = date_worker_year + '-' + date_worker_month + '-' + date_worker_day;
    var working_day = new Date(working_day_format);

    //-----
    var other_day = new Date(working_day);
    if(next_day_flag == false) { // 전날
        other_day.setDate(working_day.getDate() - 1);
    }
    else { // 다음날
        other_day.setDate(working_day.getDate() + 1);
    }

    //
    var other_day_format_year = String(other_day.getFullYear());
    var other_day_format_month = String((other_day.getMonth() + 1));
    var other_day_format_day =  String(other_day.getDate());

    if(other_day_format_month.length <= 1) {
        other_day_format_month = '0'+ other_day_format_month;
    }
    if(other_day_format_day.length <= 1) {
        other_day_format_day = '0' + other_day_format_day;
    }
    var other_day_format_yyyymmdd =  other_day_format_year + other_day_format_month + other_day_format_day;
    return other_day_format_yyyymmdd;
}

function option_tweet_list_view_hide()
{
    var btn_list_view_hide = document.getElementById('btn_tweet_list_view_hide');
    if(btn_list_view_hide != null) {
        document.getElementById('tweet_list_view_hide').value = btn_list_view_hide.checked;

        var list_view_optiom_area = document.getElementById('list_view_optiom_area');
        if(btn_list_view_hide.checked) {
            if(list_view_optiom_area != null) {
                list_view_optiom_area.hidden = true;
            }
        }
        else {
            if(list_view_optiom_area != null) {
                list_view_optiom_area.hidden = false;
            }
        }
        cmd_tweet_list_view_hide(btn_list_view_hide.checked);
    }
    if(document.getElementById('twit-list').hidden == false) {
        //-updateTwitListHtml(); 구조 변경으로 여기서 호출하면 안 된다.
    }
}

function refreshTwitListHtml()
{   // view-option 바뀌었을 때 그것을 반영하기 위해서 첫페이지를 다시 불러서 출력한다.
    // 웹브라우저를 다시 로딩하는 것과는 다르다.
    // 웹브라우저를 다시 로딩하면 새로 바뀐 설정값이 무효화되어서 초기화 효과만 생기고 
    // 원하는 상태로 출력되지 않는다.

    // trend-related
    initTwitTrendList();    
    
    //-----
    // option-init
    //-----
    var null_effect = '';
    set_ById_info(null_effect, 'view_last_id');
    set_ById_info(null_effect, 'view_latest_id');
    set_ById_info_time(null_effect, 'view_latest_id_time');
    set_ById_info_time(null_effect, 'view_last_id_time');
    set_ById_info(null_effect, 'tweet_read_count');
    set_ById_info(0, 'total_read_count');
    
    document.getElementById('twit-list').innerHTML = null_effect;

    // call
    getTwitList(true); // 'Get New Tweet'
}

function open_new_window(win_address, screenX = 0, screenY = 0) 
{
  if((twit_mini_window != null) && (twit_mini_window.closed == false)) {
    twit_mini_window.focus();
    twit_mini_window_timer_counter = 0; // timer-count 초기화
    return false;
  }
  //---
  if(twit_mini_window_timer != 0) {
    clearInterval(twit_mini_window_timer);
  }
  twit_mini_window_timer_counter = 0; // timer-count 초기화
  //-twit_mini_window_timer = setTimeout(focus_window(), 5000);
  //-twit_mini_window_timer_counter = setInterval(focus_window, 1000);
  
  //
  var open_win_width = 730, open_win_height = 760;

  // center-window
  //-var wLeft = window.screenLeft ? window.screenLeft : window.screenX;
  //-var wTop = window.screenTop ? window.screenTop : window.screenY;
  //-var center_left = wLeft + (window.innerWidth / 2) - (open_win_width / 2);
  //-var center_top = wTop + (window.innerHeight / 2) - (open_win_height / 2);
  var wLeft = window.screenX;
  var wTop = window.screenY;
  var center_left = wLeft - (open_win_width / 2);
  var center_top = wTop + (open_win_height / 2);
  
  //
  var par_address = win_address
  var location_st = '';
  location_st += 'width=' + open_win_width;
  location_st += ',';
  location_st += 'height=' + open_win_height;
  if(center_left > 0) {
    location_st += ',';
    location_st += 'left=';
    location_st += center_left;
  }
  if(center_top > 0) {
    location_st += ',';
    location_st += 'top=';
    location_st += center_top;
  }
  twit_mini_window = window.open(par_address, "twitwindow", location_st);
  if(twit_mini_window != null) {
    twit_mini_window.focus();
    //-twit_mini_window_timer = twit_mini_window.setTimeout(focus_window(), 1000);
  }
  return false;
}

function close_window() 
{
  //---
  if((twit_mini_window != null) && (twit_mini_window.closed == false)) {
    twit_mini_window.close();
  }  
  twit_mini_window = null;

  //---
  if (twit_mini_window_timer != 0) {
      clearInterval(twit_mini_window_timer);
  }
  twit_mini_window_timer = 0;

  //---
  twit_mini_window_timer_counter = 0;
}

function focus_window()
{
  if(twit_mini_window_timer_counter > 7) { // 7초가 지나면 닫는다.
    close_window();
  }
  else {
    if(twit_mini_window != null) {
      //-twit_mini_window_timer_counter++;
      twit_mini_window.focus();
    }
  }
}

function isCompleteDownload() 
{
    var total_rec_count_by = document.getElementById('disp_total_rec_count');
    var total_read_count_by = document.getElementById('disp_total_read_count');

    if((total_rec_count_by == null) || (total_read_count_by == null)) {
        return false;
    }

    var total_rec_count = parseInt(total_rec_count_by.innerHTML);
    var total_read_count = parseInt(total_read_count_by.innerHTML);
    if(total_rec_count == total_read_count) {
        return true;
    }
    return false;
}

function goto_date()
{
    var dateChoice = document.getElementById("dateSelector").value; // format: 2018-01-01
    
    // 바꿔준다.
    var day_format_year = dateChoice.slice(0, 4);
    var day_format_month = dateChoice.slice(5, 7);
    var day_format_day = dateChoice.slice(8, 10);

    var other_day_address = 'twit_v.php?';
    var day_parameter = 'year=' + day_format_year + '&month=' + day_format_month +  '&day=' + day_format_day;
    var other_day_link = other_day_address + day_parameter;
 
    window.open(other_day_link, '_' + day_parameter);

}

function catchTwitDayList(twitListingNum = 31, from_latest = false) 
{
    if (twitListingNum == undefined) {
        alert('logical-error : undefined catchTwitList()');
        return false;
    }
    if(twitListingNum < 1) {
        alert('logical-error : (twitListingNum < 1)');
        return false;
    }

    //-----
    //-----
    var twit_from_latest = from_latest;

    //-----
    //-----
    //-twit_timeline_timetable = []; // array 

    //-----
    var result_msg;
    var tpx_command = __twit_command_get_timeline__;

    //----- 
    //----- 
    var tpx_twit_day_list = '&daylist' + '=' + 'true';
    var tpx_from_latest = '&from_latest' + '=' + twit_from_latest;
    var tpx_twit_list_num = '&listnum' + '=' + twitListingNum;
   

    var newData = 'action=' + tpx_command + 
            tpx_twit_day_list + 
            tpx_from_latest + 
            tpx_twit_list_num;
    //--- console.log(newData);

    //-----    
    //-----
    var xhttp;
    var command = processing_command;
    xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (xhttp.readyState == 4 && xhttp.status == 200) {
            //--- console.log(xhttp.responseText + '\r\n');
            var responseTwit = xhttp.responseText.split(__twit_result_sect_delimiter);
            //--- console.log(responseTwit);

            var isAlready;
            var Response_TwitNum = 0;
           
            var Response_Last_Time = '';
            var Response_Latest_Time = '';

            var time_first = '', time_last = '';
            var transTwitDayList_Result = {twitNum: 0, time_latest:'', time_last:''};
        
            for (var i = 0; i < responseTwit.length; i++) {
                isAlready = responseTwit[i].indexOf(__dsm_result_state_error__);
                if (isAlready >= 0) {
                    isAlready = responseTwit[i].indexOf(__twit_result_error_rate_limit_exceed__); // twit-rata-limit-exceed
                    if(isAlready >= 0) {
                        //-timer_sleep_double_restart(__twit_working_sleep_double__); // 대기시간을 2배로 늘린다.
                        result_msg = dsm_working_ing;
                    }
                    else {
                        //-stopTwitList(from_latest);
                        result_msg = dsm_working_error;
                        console.log(xhttp.responseText + '\r\n');
                        
                        alert(dsm_working_error);
                        alert(xhttp.responseText);

                        // 읽은 것이 없어도 사용자 UI를 위해서 목록출력을 불러줘야 한다.
                        updateTwitDayListHtml();
                        //-updateTwitTrendList();
                        //-select_twitlist_menu();
                    }
                    break;
                }
                isAlready = responseTwit[i].indexOf(__twit_result_state_twit_num__);
                if (isAlready >= 0) {
                    Response_TwitNum = getPairKeyValue(responseTwit[i], __twit_result_state_twit_num__);
                    //--- alert(Response_TwitNum);
                    result_msg = dsm_working_ing;
                    continue;
                }
                isAlready = responseTwit[i].indexOf(__twit_result_state_twit_list__);
                if (isAlready >= 0) {
                    //-timer_stop_wordlist(); // finish: stop-timer
                    var TwitListReponse = getPairKeyValue(responseTwit[i], __twit_result_state_twit_list__);
                    if (TwitListReponse.length <= 0) {
                        // 오류가 아니라 내용이 없는 경우
                        result_msg = TwitListReponse;
                    } else { // 내용이 있는 경우
                        transTwitDayListFromTwitReponse(TwitListReponse, transTwitDayList_Result);
                        if (transTwitDayList_Result.twitNum <= 0) { // 값이 없는 경우인데, 실제 데이터가 없거나 논리적인 오류일 경우
                            console.log('no twit-day-list');
                            result_msg = dsm_result_no;
                        } else {
                            //----------
                            //----------
                            // 다음에 읽을 수 있도록 맨끝 트윗의 id
                            time_first = transTwitDayList_Result.time_latest; // first-item
                            time_last = transTwitDayList_Result.time_last; // last-item

                            updateTwitDayListHtml();
                            //-updateTwitTrendList();
                            //-select_twitlist_menu();
                        }
                    }
                    //-----
                    // next-count-set
                    //-----
                                        
                    // debug-control
                    if (transTwitDayList_Result.twitNum <= 0) {
                        // 값이 없는 경우인데, 실제 데이터가 없거나 논리적인 오류일 경우
                        console.log('no twit-day-list' + '\r\n');
                        console.log(xhttp.responseText + '\r\n');
                        result_msg = dsm_result_no;
                    }

                    //-----
                    // update - last & latest
                    //-----
                    if(transTwitDayList_Result.twitNum <= 0) { 
                        // 읽은 것이 없는 경우 - 둘 중에 하나, 트윗서버 지연이거나 트윗서버로부터 가장 최신까지 읽고나서 더 이상 트윗이 없는 경우
                        // ===> 계속해서 새 트윗을 읽는 것이므로 아무것도 하지 않는다.
                    }
                    else {
                        //-update_view_last_id_info(Response_LastID, Response_Last_Time);
                        //-update_view_latest_id_info(Response_LatestID, Response_Latest_Time);
                    }

                    //-----
                    //-break; 
                    //-----
                    // 여기서 브레이크를 걸지 않는다.
                    // - 논리적으로 트윗 목록 다음에 에러-메시지가 오는 경우가 있어서 그럴 경우를 위해서 다음으로 가도록 넘겨준다.
                    continue;
                }
                isAlready = responseTwit[i].indexOf(__twit_mysql_error_msg_undefine_var__);
                if (isAlready >= 0) { // mysql-undefined-variable
                    //-stopTwitList(from_latest);
                    alert(__twit_mysql_error_msg_undefine_var__);
                    result_msg = dsm_working_error;
                    console.log(xhttp.responseText + '\r\n');
                    break;
                }
                isAlready = responseTwit[i].indexOf(__twit_mysql_error_msg_catchable_fatal__);
                if (isAlready >= 0) { // mysql-undefined-variable
                    //-stopTwitList(from_latest);
                    alert(__twit_mysql_error_msg_catchable_fatal__);
                    result_msg = dsm_working_error;
                    console.log(xhttp.responseText + '\r\n');
                    break;
                }
                isAlready = responseTwit[i].indexOf(__twit_mysql_error_msg_connect__);
                if (isAlready >= 0) { // mysql-undefined-variable
                    //-stopTwitList(from_latest);
                    alert(__twit_mysql_error_msg_connect__);
                    result_msg = dsm_working_error;
                    console.log(xhttp.responseText + '\r\n');
                    break;
                }                
            }
            if (responseTwit.length <= 0) {
                result_msg = dsm_result_no;
            }
            else {
            }
            //-----
            //-----
        }
    };
    //-xhttp.open('GET', command+newData, true);
    //-xhttp.send();   

    xhttp.open('POST', command, true);
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhttp.send(newData);

    //
    return true;
}

function transTwitDayListFromTwitReponse(TwitListSeries, transTwitDayList_Result)
{
    // init-reset
    twit_day_list_worker = []; // array 

    // init
    transTwitDayList_Result.twitNum = 0;
    
    //
    var tablename = document.getElementById('sys_info_tablename').value;
    var TwitList_Array = TwitListSeries.split(__twit_result_state_twit_line__);
    var findPos;
    var twit_last_id = '';
    var rwit_last_id_time = '';
    var twit_cnt = 0;
    var twit_first = false;
    for (twit_cnt = 0; twit_cnt < TwitList_Array.length; twit_cnt++) {
        if (TwitList_Array[twit_cnt].length == 0) { // __twit_result_state_twit_line__ 있고 내용이 없는 경우 - 맨 뒤에 추가 붙는 것이 있다.
            continue;
        }
        var oneTwit = TwitList_Array[twit_cnt];
        oneTwit = oneTwit.trim();
        if (oneTwit.length <= 0) {
            continue;
        }

        //
        var TwitFieldList = oneTwit.split(__twit_result_field_delimiter);
        if (TwitFieldList.length <= 1) {
            continue;
        }

        var twit_tablename = '';
        var twit_order = 0;
        var twit_time = '';
        var twit_yyyymmdd = '';
        for (var field_cnt = 0; field_cnt < TwitFieldList.length; field_cnt++) {
            var TwitField = TwitFieldList[field_cnt];
            TwitField = TwitField.trim();
            if (TwitField.length <= 0) {
                continue;
            }

            //
            findPos = TwitField.indexOf(__twit_result_state_twit_order__);
            if(findPos >= 0) {
                twit_order = getPairKeyValue(TwitField, __twit_result_state_twit_order__);
            }
            findPos = TwitField.indexOf(__twit_result_state_tablename__);
            if(findPos >= 0) {
                twit_tablename = getPairKeyValue(TwitField, __twit_result_state_tablename__);
                if(tablename.length > 1) {
                    if(twit_tablename.length > tablename.length) {
                        // format: tablename_yyyymmdd
                        twit_yyyymmdd = twit_tablename.substring(tablename.length);
                        if(twit_yyyymmdd.charAt(0) == '_') {
                            twit_yyyymmdd = twit_tablename.substring(tablename.length + 1);
                            if(twit_yyyymmdd.length == 8) {
                                var twit_yyyy = twit_yyyymmdd.substring(0, 4);
                                var twit_mm = twit_yyyymmdd.substring(4, 6);
                                var twit_dd = twit_yyyymmdd.substring(6, 8);
                                var twit_yyyy_mm_dd = twit_yyyy + '-' + twit_mm + '-' + twit_dd;
                                twit_time = new Date(twit_yyyy_mm_dd);
                                twit_time = twit_yyyymmdd;
                            }
                        }
                    }
                }
                
            }
        }
        
        //
        transTwitDayList_Result.twitNum++;

        //-----
        //-----
        var twitItem = { order:     twit_order, 
                        table_name:  twit_tablename
                        };
        twit_day_list_worker.push(twitItem);
        
        //-var twitItem_4_all = twitItem;
        //-twit_day_list_all.push(twitItem_4_all);

        //-----
        //-----
        if(twit_first == false) {
            twit_first = true;
            //-update_twit_date_worker(twit_time);
        }

        //-----
        //-----
        if(transTwitDayList_Result.time_latest.length <= 0) {
            transTwitDayList_Result.time_latest = twit_time;
        }
        transTwitDayList_Result.time_last = twit_time;
    }

    // time-old-new-check
    var time_reverse_flag = false;
    if(transTwitDayList_Result.time_latest.localeCompare(transTwitDayList_Result.time_last) < 0) {
        // 맨 앞 것이 맨 뒤 것보다 시간적으로 옛날인 경우
        var saveValue = transTwitDayList_Result.time_latest;
        transTwitDayList_Result.time_latest = transTwitDayList_Result.time_last;
        transTwitDayList_Result.time_last = saveValue;

        //
        time_reverse_flag = true;
    }
    if(time_reverse_flag == true) {
        // 서버로부터 받은 트윗 목록이 {오래된 것}부터 {최신 것}으로 된 것이면 
        // 순서를 반대로 바꿔준다. 이 함수 밖에서는 항상 [최신->옛날] 트윗 순서대로 처리한다.
        var twit_timeline_reverse = []; // array 
        for (twit_cnt = (twit_day_list_worker.length - 1); twit_cnt >= 0; twit_cnt--) {
            var twitItem = twit_day_list_worker[twit_cnt];
            twit_timeline_reverse.push(twitItem);
        }        
        twit_day_list_worker = twit_timeline_reverse;
    }

    //
    return ;
}
