var twit_timeline_list_all = []; // array-twit
var twit_trend_list_user = []; // array-user(username@screenname)
var twit_trend_list_hash = []; // array-hashtag 
var twit_trend_list_time = []; // array-timeline 
var twit_trend_list_timecycle = []; // array-timecycle


var field_delimiter_string = "&nbsp;";
var field_delimiter_string3 = "&nbsp;&nbsp;&nbsp;";

var twit_trend_list_hash_stop_use = true;
//-var twit_trend_list_hash_stop_use = false;
var twit_trend_list_hash_stop_sorted = false;
var twit_trend_list_hash_stop = [
    // etc
    "#팩트TV후원1877_0411",
    // repeat
    "#JTBC뉴스룸",
    "#JTBC_정치부회의",
    "#GO현장",
    "#K스타",
    "#K패션",
    "#Live",
    "#MBC_뉴스",
    "#MBC_뉴스데스크",
    "#MBC_스페셜",
    "#PD수첩",
    "#100분_토론",
    "#김현경의_시선",
    "#나는자연인이다",
    "#나이트라인",
    "#날씨",
    "#뉴스",
    "#뉴스공장",
    "#뉴스룸",
    "#뉴스브리핑",
    "#뉴스픽",
    "#뉴스pic",
    "#뉴스pick",
    "#뉴스핌",
    "#뉴스특보",
    "#다시보기",
    "#데이터룸",
    "#뒷이야기",
    "#라이브는JTBC",
    "#라이프",
    "#리서치뷰",
    "#리얼스토리_눈",
    "#모바일한경1면",
    "#미디어오늘",
    "#밀착취재",
    "#밀착카메라",
    "#본방사수",
    "#생방송",
    "#생생한세계뉴스",
    "#생중계", 
    "#속보",
    "#스브스뉴스",
    "#스브스타",
    "#스포츠",
    "#영상",
    "#영상픽",
    "#앵커브리핑",
    "#앵커의_시선",
    "#엠빅뉴스",
    "#오늘_밤_12시_20분",
    "#오늘날씨",
    "#오후2시10분_본방사수",
    "#오후2시10분",
    "#이슈플러스",
    "#이시각세계",
    "#인터뷰",
    "#자막뉴스",
    "#저녁_7시_55분",
    "#정치부회의",
    "#추적60분",
    "#취재기자",
    "#취재파일",
    "#취재후",
    "#카드뉴스",
    "#컬투쇼",
    "#클로징",
    "#특별인터뷰",
    "#특파원리포트",
    "#프로농구",
    "#프로배구",
    "#프로야구",
    "#프로축구",
    "#한국경제신문1면",
    "#현장IN",
    //--- repeat_person ---
    "#강경훈기자",
    "#굿모닝뉴스_박재홍입니다",
    "#김은혜",
    "#김주하",
    "#송지헌",
    "#한성원",
    "#이완배기자",
    //--- company ---
    "#JTBC",
    "#KBS", 
    "#MBC", 
    "#MBN",
    "#OBS",
    "#SBS",
    "#SNS",
    "#TV조선",
    "#YTN",
    "#zdk",
    "#동아일보",
    "#매경",
    "#매일경제",
    "#매일경제TV",
    "#연합뉴스TV",
    "#연합뉴스",
    "#유튜브", 
    "#일요신문",
    "#조선비즈",
    "#조선일보",
    "#중앙일보",
    "#파이낸셜뉴스",
    "#팩트TV",
    "#페북",
    "#프레시안",
    "#페이스북",
    "#한겨레",
    "#한겨레신문",
];

function initTwitTrendList()
{
    twit_timeline_list_all = []; // array-twit
    twit_trend_list_user = []; // array-user(username@screenname)
    twit_trend_list_hash = []; // array-hashtag 
    twit_trend_list_time = []; // array-timeline 
    twit_trend_list_timecycle = []; // array-timecycle
}

function updateTwitTrendList()
{
    //---
    // init
    //---
    // 서버에 trendlist 전송할 때 사용하는 변수 초기화
    // - 출력 내용이 새롭게 바뀌면 서버 전송 상태도 초기화되어야 한다.
    document.getElementById('tweet_send_trend_list_blocknum').value = 0; // 서버에 trendlist 전송할 때 사용하는 변수 초기화
    document.getElementById('tweet_send_trend_list_blocknum').value = 0; // 서버에 trendlist 전송할 때 사용하는 변수 초기화

    //
    var TwitTrendListText = '';

    //---
    //---
    var twitlist_menu_cmd = get_twitlist_menu_command();
    if(twitlist_menu_cmd === 'tweet') {
    }
    else if(twitlist_menu_cmd === 'user') {
        TwitTrendListText = makeTwitTrendListHtml_User(twit_trend_list_user);
    }
    else if(twitlist_menu_cmd === 'hash') {
        TwitTrendListText = makeTwitTrendListHtml_Hash(twit_trend_list_hash);
    }
    else if(twitlist_menu_cmd === 'time') {
        TwitTrendListText = makeTwitTrendListHtml_Time(twit_trend_list_time);
    }
    else if(twitlist_menu_cmd === 'timecycle') {
        TwitTrendListText = makeTwitTrendListHtml_TimeCycle(twit_trend_list_timecycle);
    }
    else {
        alert('logic-error : ' + 'get_twitlist_menu_command()');
    }
    document.getElementById('twit-trend').innerHTML = TwitTrendListText;
}

function updateTwitTrendList_twitItem(twitItem, timeline_unit = 60, timecycle_unit = 5)
{
    //
    var twitID = twitItem["twit_id"];
    var twitRecText = twitItem["text"];
    var twitTime = twitItem["time"];
    var twitUserID = twitItem["user_id"];
    var twitRecUsername = twitItem["user_name"]
    var twitScreenname = twitItem["screen_name"];
    var urlencoded_state = twitItem["urlencoded"];
    
    var twitUsername = '';
    var twitUsernameDecoded = '';
    var twitText = '';

    var twitTime_value = new Date(twitTime);
    var twitTimeString = get_tweet_time_string(twitTime_value, true);

    //-----
    // encode-check
    //-----
    if(urlencoded_state == true) {
        //-----
        //-var urlencoded_debug = true;
        var urlencoded_debug = false;
        if(urlencoded_debug == true) { // debug
            console.log('debug (' + twitScreenname +  ' / ' + twitRecUsername + ') ' +  twitTimeString + ')  list_inx: ' + list_inx); //debug
            if(list_inx >= 21) { // debug
                list_inx++;
                list_inx--;
            }
        }
        
        //-----
        twitUsernameDecoded = urldecode(twitRecUsername);
        var twitTextDecoded = urldecode(twitRecText);

        twitText = twitTextDecoded;
        twitUsername = twitUsernameDecoded;

        //-----
        if(urlencoded_debug == true) { // debug
            console.log('debug (' + twitScreenname +  ' / ' + twitUsernameDecoded + ' : ' + twitTimeString + ')  list_inx: ' + list_inx); //debug
            //-if((twitRecText[0] == '%') && (twitRecText[1] == '2') && (twitRecText[2] == '5')) {
            //-    var twitTextDecoded_2 = urldecode(twitTextDecoded);
            //-    console.log('debug : ' + twitTextDecoded_2); //debug
            //-}
        }
    }
    else {
        twitText = twitRecText;
        twitUsername = twitRecUsername;
    }

    /*
    //-----
    //-----
    // tag-변환(\r\n->br, )
    var twitText_Tag = makeTwitText_Tagify(twitText);
    twitText = twitText_Tag;

    // twit-short-url 화면에서 가릴 것인지:  https://t.co/XYNOOkNHwa
    var twitText_shortUrl = makeTwitText_ShortUrlButton(twitText, tweet_ShortUrlReplaceString);

    // 본문에서 '@~~~' 블록을 바꾼다.
    var twitText_ScreenName = makeTwitText_ScreenName(twitText_shortUrl, list_view_screenname_scratch, tweet_ScratchReplaceString);
    twitText_shortUrl = twitText_ScreenName;

    // hash-string
    var twitText_Hash = makeTwitText_HashMark(twitText_shortUrl);
    twitText_shortUrl = twitText_Hash;
    */

    //-----
    // trend-user
    //-----
    var trend_item_user = [];
    var user_time_item = {
        twit_id:    twitID,
        twit_time:  twitTime
    };

    var arrayIndex = twit_trend_list_user.map(function (trend_item) { return trend_item.user_id; }).indexOf(twitUserID);
    if(arrayIndex >= 0) {
        trend_item_user = twit_trend_list_user[arrayIndex];
        trend_item_user.freq++;
        trend_item_user.time_list.push(user_time_item);
    }
    else {
        //-
        var user_time_list = [];
        user_time_list.push(user_time_item);
        var order = (twit_trend_list_user.length + 1);
        trend_item_user = {
            order:      order, 
            user_id:    twitUserID, 
            user_name:  twitUsername, 
            screen_name:twitScreenname, 
            time_list:  user_time_list,
            freq:       1
        };
        twit_trend_list_user.push(trend_item_user);
    }

    //-----
    // trend-hash
    //-----
    var HashMarkArray = getTwitText_HashMark(twitText);
    for(var inx = 0; inx < HashMarkArray.length; inx++) {
        //
        var hashMarkItem = HashMarkArray[inx];
        hashMarkItem = String(hashMarkItem);
        //-console.log(hashMarkItem); // debug

        //
        var hash_user_list = [];
        var hash_user_item = {
            user_id:    twitUserID, 
            user_name:  twitUsername, 
            screen_name:twitScreenname, 
            freq: 1
        };
        
        //
        var hashIndex = twit_trend_list_hash.map(function (trend_item) { return trend_item.hash; }).indexOf(hashMarkItem);
        if(hashIndex >= 0) {
            var trend_hash_find = twit_trend_list_hash[hashIndex];
            trend_hash_find.freq++;

            // user-check
            var userlist_find = trend_hash_find.userlist;

            //---
            var userIndex = userlist_find.map(function (user_item) { return user_item.user_id; }).indexOf(twitUserID);
            if(userIndex >= 0) {
                userlist_find[userIndex].freq++;
            }
            else { // 해시에 등록된 사용자 목록에 없는 경우 - 사용자 정보를 등록
                userlist_find.push(hash_user_item);
            }
        }
        else {  //- 새로운 해시태그 - 등록
            var order = (twit_trend_list_hash.length + 1);
            hash_user_list.push(hash_user_item);
            var trend_item_hash = {
                order:      order, 
                hash:       hashMarkItem,
                userlist:   hash_user_list,
                freq:       1
            };
            twit_trend_list_hash.push(trend_item_hash);
        }
    }

    //-----
    // trend-timeline
    //-----
    var twitTime_Date =  new Date(twitTime);
    var twitMinUnit_milliSec = transDateUnit_ByMin(twitTime_Date, timeline_unit);
    if(twitMinUnit_milliSec <= 0) {
        return false;
    }
    
    var trend_item_time = [];
    var time_twit_item = {
        twit_id:    twitID,
        twit_time:  twitTime,
        user_id:    twitUserID, 
        user_name:  twitUsername, 
        screen_name:twitScreenname
    };

    arrayIndex = twit_trend_list_time.map(function (time_item) { return time_item.time_millisec; }).indexOf(twitMinUnit_milliSec);
    if(arrayIndex >= 0) {
        trend_item_time = twit_trend_list_time[arrayIndex];
        trend_item_time.freq++;
        trend_item_time.twit_list.push(time_twit_item);
    }
    else {
        //-
        var time_twit_list = [];
        time_twit_list.push(time_twit_item);
        var order = (twit_trend_list_time.length + 1);
        trend_item_time = {
            order:          order, 
            time_millisec:  twitMinUnit_milliSec,
            twit_list:      time_twit_list,
            freq:           1
        };
        twit_trend_list_time.push(trend_item_time);
    }

    //-----
    // trend-timecycle
    //-----
    var twitTime_Date =  new Date(twitTime);
    var twitMinUnit_cycle = transDateUnit_ByMinCycle(twitTime_Date, timecycle_unit);
    if(twitMinUnit_cycle < 0) { // '0'은 의미있는 값이다.
        return false;
    }
    
    var trend_item_time = [];
    var time_twit_item = {
        twit_id:    twitID,
        twit_time:  twitTime,
        user_id:    twitUserID, 
        user_name:  twitUsername, 
        screen_name:twitScreenname
    };

    arrayIndex = twit_trend_list_timecycle.map(function (time_item) { return time_item.time_cycle; }).indexOf(twitMinUnit_cycle);
    if(arrayIndex >= 0) {
        trend_item_time = twit_trend_list_timecycle[arrayIndex];
        trend_item_time.freq++;
        trend_item_time.twit_list.push(time_twit_item);
    }
    else {
        //-
        var time_twit_list = [];
        time_twit_list.push(time_twit_item);
        var order = (twit_trend_list_timecycle.length + 1);
        trend_item_time = {
            order:      order, 
            time_cycle: twitMinUnit_cycle,
            twit_list:  time_twit_list,
            freq:       1
        };
        twit_trend_list_timecycle.push(trend_item_time);
    }
    
    //
    return true;
}

function makeTwitTrendListHtml_User(twit_trend_list, copyTextMode = false) 
{
    //
    var innerHtm = "";

    //---
    //---
    var timelist_show = false;
    var btn_user_timelist_show = document.getElementById('btn_twitlist_view_user_timelist_show');
    if((btn_user_timelist_show != null) && (btn_user_timelist_show.checked)) {
        timelist_show = true;
    }
    
    //
    var order_by_freq = true;

    var twitlist_menu_user_order = document.getElementById('twitlist_menu_user_order');
    var twitlist_menu_user_freq = document.getElementById('twitlist_menu_user_freq');
    var twitlist_menu_user_name = document.getElementById('twitlist_menu_user_name');
    if((twitlist_menu_user_order != null) && (twitlist_menu_user_order.checked)) { // 순위순
        twit_trend_list.sort(function(first, second) { // 순위-이름순
            var comVal = first.order - second.order; // 올림차순
            //-var comVal = second.order - first.order; // 내림차순
            if(comVal == 0) {
                comVal = first.user_name.localeCompare(second.user_name); // 오름차순
            }
            return comVal;
        }); 
    }
    else if((twitlist_menu_user_freq != null) && (twitlist_menu_user_freq.checked)) { // 빈도순
        twit_trend_list.sort(function(first, second) { // (큰)빈도-이름순
            //-var comVal = first.freq - second.freq; // 올림차순
            var comVal = second.freq - first.freq; // 내림차순
            if(comVal == 0) {
                comVal = first.user_name.localeCompare(second.user_name); // 오름차순
            }
            return comVal;
        }); 
    }
    else if((twitlist_menu_user_name != null) && (twitlist_menu_user_name.checked)) { // 이름순
        twit_trend_list.sort(function(first, second) { // 이름-(큰)빈도
            //-var comVal = second.user_name.localeCompare(first.user_name); // 올림차순
            var comVal = first.user_name.localeCompare(second.user_name); // 오름차순
            if(comVal == 0) {
                comVal = second.freq - first.freq; // 내림차순
            }
            return comVal;
        }); 
    }
    else {
        // 메뉴가 없으면 {빈도순}으로 한다.
        //-alert('logic-error: ');
        //-return innerHtm;
        twit_trend_list.sort(function(first, second) { // (큰)빈도-이름순
            //-var comVal = first.freq - second.freq; // 올림차순
            var comVal = second.freq - first.freq; // 내림차순
            if(comVal == 0) {
                comVal = first.user_name.localeCompare(second.user_name); // 오름차순
            }
            return comVal;
        }); 
    }
    
    //---------------
    //-var htmlFormatFalg = true;
    var htmlFormatFalg = false;
    var twitText_newline_flag = true;
    //-var twitText_newline_flag = false;
    var tweet_ShortUrlReplaceString = '🔗';
    var tweet_ScratchReplaceString = '*******'

    var by_tweet_ShortUrlReplaceString = document.getElementById('tweet_ShortUrlReplaceString');
    if(by_tweet_ShortUrlReplaceString != null) {
        if(by_tweet_ShortUrlReplaceString.value.length > 0) {
            tweet_ShortUrlReplaceString = by_tweet_ShortUrlReplaceString.value;
        }
    }
    var by_tweet_ScratchReplaceString = document.getElementById('tweet_ScratchReplaceString');
    if(by_tweet_ScratchReplaceString != null) {
        if(by_tweet_ScratchReplaceString.value.length > 0) {
            tweet_ScratchReplaceString = by_tweet_ScratchReplaceString.value;
        }
    }
    var by_tweet_list_view_html_format = document.getElementById('tweet_list_view_html_format');
    if(by_tweet_list_view_html_format != null) {
        var tweet_list_view_html_format = String(by_tweet_list_view_html_format.value);
        if(tweet_list_view_html_format === '1') {
            htmlFormatFalg = true;
        }
        if(tweet_list_view_html_format === 'true') {
            htmlFormatFalg = true;
        }
    }
    if(copyTextMode == true) { // copy를 위한 텍스트일 때에는 html 태그를 만들지 않는다.
        htmlFormatFalg = false;
    }
    var list_view_detail_hide = false;
    var by_tweet_list_view_detail_hide = document.getElementById('tweet_list_view_detail_hide');
    if(by_tweet_list_view_detail_hide != null) {
        var tweet_list_view_detail_hide = String(by_tweet_list_view_detail_hide.value);
        if(tweet_list_view_detail_hide === '1') {
            list_view_detail_hide = true;
        }
        if(tweet_list_view_detail_hide === 'true') {
            list_view_detail_hide = true;
        }
    }

    if(htmlFormatFalg == true) {
        twitText_newline_flag = false;
    }

    //
    if(twit_trend_list.length <= 0) { // 출력할 게 없는 경우
        return innerHtm;
    }

    // 목록 출력 최댓값 확인
    var list_view_max = 0;
    var twit_list_view_max = document.getElementById('tweet_list_view_max');
    if(twit_list_view_max != null) {
        list_view_max = parseInt(twit_list_view_max.value);
    }
    var list_view_order = false;
    var twit_list_view_order = document.getElementById('btn_tweet_list_view_order');
    if((twit_list_view_order != null) &&
        (twit_list_view_order.checked)) {
        list_view_order = true;
    }
    var list_view_twit_id = false;
    var twit_list_view_twit_id = document.getElementById('btn_tweet_list_view_twit_id');
    if((twit_list_view_twit_id != null) &&
        (twit_list_view_twit_id.checked)) {
        list_view_twit_id = true;
    }
    var list_view_username = false;
    var twit_list_view_username = document.getElementById('btn_tweet_list_view_username');
    if(twit_list_view_username != null) {
        if(twit_list_view_username.checked) {
            list_view_username = true;
        }
    }
    var list_view_twittext = false;
    var twit_list_view_twittext = document.getElementById('btn_tweet_list_view_twittext');
    if((twit_list_view_twittext != null) &&
        (twit_list_view_twittext.checked)) {
        list_view_twittext = true;
    }
    var list_view_screenname_scratch = false;
    var twit_list_view_screenname_scratch = document.getElementById('btn_tweet_list_view_screenname_scratch');
    if((twit_list_view_screenname_scratch != null) &&
        (twit_list_view_screenname_scratch.checked)) {
        list_view_screenname_scratch = true;
    }
    var list_view_username_scratch = false;
    var twit_list_view_username_scratch = document.getElementById('btn_tweet_list_view_username_scratch');
    if((twit_list_view_username_scratch != null) &&
        (twit_list_view_username_scratch.checked)) {
        list_view_username_scratch = true;
    }

    //
    if(htmlFormatFalg == true) {
        //-innerHtm += "<table id='TwitListTable_NoBorder' >";
        innerHtm += "<table id='TwitListTable_Border' >";
    }
    else {
    }

    //
    var displayOrder = 0;
    for (var list_inx = 0; list_inx < twit_trend_list.length; list_inx++) {
        displayOrder = (1 + list_inx); // 0-base
        // 목록 출력 최댓값 확인
        if(list_view_max > 0) {
            if(list_inx > list_view_max) {
                break;
            }
        }

        //
        var twitTrendItem = twit_trend_list[list_inx];

        //
        htmTwitItem = makeTwitTrendListHtml_UserTwitItem(twitTrendItem, displayOrder, htmlFormatFalg, copyTextMode,
            list_view_order, list_view_twit_id, list_view_username, list_view_twittext, 
            list_view_detail_hide, list_view_screenname_scratch, list_view_username_scratch,
            timelist_show, 
            tweet_ShortUrlReplaceString, tweet_ScratchReplaceString);

        //---
        innerHtm += htmTwitItem;
    }
    if(htmlFormatFalg == true) {
        innerHtm += "</table>";
    }
    else {
    }

    //-console.log(innerHtm + '\r\n');
    return innerHtm;
}

function makeTwitTrendListHtml_UserTwitItem(twitTrendItem, displayOrder, htmlFormatFalg, copyTextMode,
    list_view_order, list_view_twit_id, list_view_username, list_view_twittext, 
    list_view_detail_hide, list_view_screenname_scratch, list_view_username_scratch,
    timelist_show, 
    tweet_ShortUrlReplaceString, tweet_ScratchReplaceString) 
{
    //
    var htmTwitTrendItem = " ";
    
    //---------------
    var order = twitTrendItem["order"];
    var twitUserID = twitTrendItem["user_id"];
    var twitUsername = twitTrendItem["user_name"]
    var twitScreenname = twitTrendItem["screen_name"];
    var twitTimeList = twitTrendItem["time_list"];
    var twitFreq = twitTrendItem["freq"];

    var twitBody = '';

    //-----
    //-----
    if(copyTextMode == true) { // copy를 위한 TextMode 일 때
        field_delimiter_string = "\t";
        field_delimiter_string3 = "\t"; // 필드 구분은 탭(\t)문자로만 하기 때문에 1글자만 사용
    }
    else {
        field_delimiter_string = "&nbsp;";
        field_delimiter_string3 = "&nbsp;&nbsp;&nbsp;"; // 필드 구분은 공백(space)문자로 3글자 사용
    }

    //-----
    //-----
    var twitScreenname_new;
    if(list_view_screenname_scratch == true) {
        var twitScreenname_array = __getSymbols__(twitScreenname);
        twitScreenname_new = twitScreenname_array[0];
        twitScreenname_new += tweet_ScratchReplaceString;
    }
    else {
        twitScreenname_new = twitScreenname;
    }
    var twitUsername_new;
    if(list_view_username_scratch == true) {
        var twitUsername_array = __getSymbols__(twitUsername);
        twitUsername_new = twitUsername_array[0];
        twitUsername_new += tweet_ScratchReplaceString;
    }
    else {
        twitUsername_new = twitUsername;
    }

    //-----
    //- goto user : format - https://twitter.com/{Screenname}
    //-----
    var goto_anchor = '';
    if(copyTextMode == true) { // copy를 위한 TextMode 일 때
        //-goto_anchor = twitUsername_new + '@' + twitScreenname_new;
        goto_anchor = twitUserID + field_delimiter_string + twitUsername_new + field_delimiter_string + twitScreenname_new;
    }
    else {
        goto_anchor = makeGotoString_User(twitScreenname, twitScreenname_new, twitUsername_new);
    }
    var goto_user_twit_anchor = goto_anchor;

    twitBody += goto_user_twit_anchor;
    twitBody += field_delimiter_string;


    //-----
    //-----
    var twitUserTimeList = '';
    if(timelist_show == true) {
        if(twitTimeList.length > 0) {
            if(copyTextMode == false) {
                twitUserTimeList += '<br>';
            }
        }
        for(var timecnt = 0; timecnt < twitTimeList.length; timecnt++) {
            //-var user_time_item = {
            //-    twit_id:    twitID,
            //-    twit_time:  twitTime
            //-};
            var user_time_item = twitTimeList[timecnt];

            var goto_anchor = '';
            var twitTime_value = new Date(user_time_item.twit_time);
            var twitTimeString = get_tweet_time_string(twitTime_value, true);

            if(copyTextMode == true) { // copy를 위한 TextMode 일 때
                goto_anchor = twitTimeString;
            }
            else {
                goto_anchor = makeGotoString_twitID(twitScreenname, user_time_item.twit_id, twitTimeString);
            }

            //-twitUserTimeList += twitTimeString;
            twitUserTimeList += goto_anchor;
            twitUserTimeList += "  ";            
        }
    }
   
    
    //-----
    //-----
    displayOrder = order;
    if(htmlFormatFalg == true) {
        htmTwitTrendItem += "<tr>";

        //
        if(list_view_order == true) {
            htmTwitTrendItem += "<td width=60>" + displayOrder + "</td>";
        }

        //
        if(list_view_twit_id == true) {
            //-htmTwitTrendItem += "<td width=100>" + twitID + "</td>";
        }

        //
        htmTwitTrendItem += "<td ";
        htmTwitTrendItem += " width=47 ";
        htmTwitTrendItem += ">" + twitFreq + "</td>";

        //
        htmTwitTrendItem += "<td style='text-align: left;'>";
        //-htmTwitTrendItem += twitUsername + "(" + twitScreenname + ")";
        htmTwitTrendItem += twitBody;
        htmTwitTrendItem += field_delimiter_string3;
        htmTwitTrendItem += twitUserTimeList;
        htmTwitTrendItem += "</td>";

        //
        htmTwitTrendItem += "</tr>";
    }
    else {
        if(copyTextMode == false) {
            htmTwitTrendItem += "<div id='TwitListTable_Div' >";
        }

        //
        if(list_view_order == true) {
            htmTwitTrendItem += displayOrder + field_delimiter_string;
        }

        //
        if(list_view_twit_id == true) {
            //-htmTwitTrendItem += "(" + twitID + ")" + field_delimiter_string;
        }

        //
        if(copyTextMode == false) {
            htmTwitTrendItem += twitFreq + " (회) ";
        }
        else {
            htmTwitTrendItem += twitFreq;
        }
        htmTwitTrendItem += field_delimiter_string;

        //
        //-htmTwitTrendItem += twitUsername + "(" + "@" + twitScreenname + ")";
        htmTwitTrendItem += twitBody;

        //
        htmTwitTrendItem += field_delimiter_string3;
        htmTwitTrendItem += field_delimiter_string3;
        htmTwitTrendItem += twitUserTimeList;

        //
        if(copyTextMode == false) {
            htmTwitTrendItem += "</div>";
        }
        else {
            htmTwitTrendItem += "\r\n";
        }

        //
        //-htmTwitTrendItem += "<div id='TwitListTableGab_Div' ></div>";
    }

    //-console.log(htmTwitTrendItem + '\r\n');
    return htmTwitTrendItem;
}

function makeTwitTrendListHtml_Hash(twit_trend_list, copyTextMode = false) 
{
    //
    var innerHtm = "";

    //---
    //---
    var userlist_show = false;
    var btn_hash_userlist_show = document.getElementById('btn_twitlist_view_hash_userlist_show');
    if((btn_hash_userlist_show != null) && (btn_hash_userlist_show.checked)) {
        userlist_show = true;
    }
    
    //---
    //---
    var order_by_freq = true;

    var twitlist_menu_user_freq = document.getElementById('twitlist_menu_user_freq');
    var twitlist_menu_user_name = document.getElementById('twitlist_menu_user_name');
    if((twitlist_menu_user_freq != null) && (twitlist_menu_user_freq.checked)) { // 빈도순
        order_by_freq = true;
    }
    else if((twitlist_menu_user_name != null) && (twitlist_menu_user_name.checked)) { // 이름순
        order_by_freq = false;
    }
    else {
        // 메뉴가 없으면 {빈도순}으로 한다.
        //-alert('logic-error: ');
        //-return innerHtm;
        order_by_freq = true;
    }

    //---
    //---
    if(order_by_freq == true) { // 빈도순
        twit_trend_list.sort(function(first, second) { // (큰)빈도-이름순
            //-var comVal = first.freq - second.freq; // 올림차순
            var comVal = second.freq - first.freq; // 내림차순
            if(comVal == 0) {
                comVal = first.hash.localeCompare(second.hash); // 오름차순
            }
            return comVal;
        }); 
    }
    else { // 이름순
        twit_trend_list.sort(function(first, second) { // 이름-(큰)빈도
            //-var comVal = secondx.hash.localeCompare(second.hash); // 올림차순
            var comVal = first.hash.localeCompare(second.hash); // 오름차순
            if(comVal == 0) {
                comVal = second.freq - first.freq; // 내림차순
            }
            return comVal;
        }); 
    }

    //---------------
    //-var htmlFormatFalg = true;
    var htmlFormatFalg = false;
    var twitText_newline_flag = true;
    //-var twitText_newline_flag = false;
    var tweet_ShortUrlReplaceString = '🔗';
    var tweet_ScratchReplaceString = '*******'

    var by_tweet_ShortUrlReplaceString = document.getElementById('tweet_ShortUrlReplaceString');
    if(by_tweet_ShortUrlReplaceString != null) {
        if(by_tweet_ShortUrlReplaceString.value.length > 0) {
            tweet_ShortUrlReplaceString = by_tweet_ShortUrlReplaceString.value;
        }
    }
    var by_tweet_ScratchReplaceString = document.getElementById('tweet_ScratchReplaceString');
    if(by_tweet_ScratchReplaceString != null) {
        if(by_tweet_ScratchReplaceString.value.length > 0) {
            tweet_ScratchReplaceString = by_tweet_ScratchReplaceString.value;
        }
    }
    var by_tweet_list_view_html_format = document.getElementById('tweet_list_view_html_format');
    if(by_tweet_list_view_html_format != null) {
        var tweet_list_view_html_format = String(by_tweet_list_view_html_format.value);
        if(tweet_list_view_html_format === '1') {
            htmlFormatFalg = true;
        }
        if(tweet_list_view_html_format === 'true') {
            htmlFormatFalg = true;
        }
    }
    if(copyTextMode == true) { // copy를 위한 텍스트일 때에는 html 태그를 만들지 않는다.
        htmlFormatFalg = false;
    }
    var list_view_detail_hide = false;
    var by_tweet_list_view_detail_hide = document.getElementById('tweet_list_view_detail_hide');
    if(by_tweet_list_view_detail_hide != null) {
        var tweet_list_view_detail_hide = String(by_tweet_list_view_detail_hide.value);
        if(tweet_list_view_detail_hide === '1') {
            list_view_detail_hide = true;
        }
        if(tweet_list_view_detail_hide === 'true') {
            list_view_detail_hide = true;
        }
    }

    if(htmlFormatFalg == true) {
        twitText_newline_flag = false;
    }

    //
    if(twit_trend_list.length <= 0) { // 출력할 게 없는 경우
        return innerHtm;
    }

    // 목록 출력 최댓값 확인
    var list_view_max = 0;
    var twit_list_view_max = document.getElementById('tweet_list_view_max');
    if(twit_list_view_max != null) {
        list_view_max = parseInt(twit_list_view_max.value);
    }
    var list_view_order = false;
    var twit_list_view_order = document.getElementById('btn_tweet_list_view_order');
    if((twit_list_view_order != null) &&
        (twit_list_view_order.checked)) {
        list_view_order = true;
    }
    var list_view_twit_id = false;
    var twit_list_view_twit_id = document.getElementById('btn_tweet_list_view_twit_id');
    if((twit_list_view_twit_id != null) &&
        (twit_list_view_twit_id.checked)) {
        list_view_twit_id = true;
    }
    var list_view_username = false;
    var twit_list_view_username = document.getElementById('btn_tweet_list_view_username');
    if(twit_list_view_username != null) {
        if(twit_list_view_username.checked) {
            list_view_username = true;
        }
    }
    var list_view_twittext = false;
    var twit_list_view_twittext = document.getElementById('btn_tweet_list_view_twittext');
    if((twit_list_view_twittext != null) &&
        (twit_list_view_twittext.checked)) {
        list_view_twittext = true;
    }
    var list_view_screenname_scratch = false;
    var twit_list_view_screenname_scratch = document.getElementById('btn_tweet_list_view_screenname_scratch');
    if((twit_list_view_screenname_scratch != null) &&
        (twit_list_view_screenname_scratch.checked)) {
        list_view_screenname_scratch = true;
    }
    var list_view_username_scratch = false;
    var twit_list_view_username_scratch = document.getElementById('btn_tweet_list_view_username_scratch');
    if((twit_list_view_username_scratch != null) &&
        (twit_list_view_username_scratch.checked)) {
        list_view_username_scratch = true;
    }

    //
    if(htmlFormatFalg == true) {
        //-innerHtm += "<table id='TwitListTable_NoBorder' >";
        innerHtm += "<table id='TwitListTable_Border' >";
    }
    else {
    }

    //
    var displayOrder = 0;
    for (var list_inx = 0; list_inx < twit_trend_list.length; list_inx++) {
        displayOrder = (1 + list_inx); // 0-base
        // 목록 출력 최댓값 확인
        if(list_view_max > 0) {
            if(list_inx > list_view_max) {
                break;
            }
        }

        //
        var twitTrendItem = twit_trend_list[list_inx];

        // stop-list-check
        if((twit_trend_list_hash_stop_use == true) && (twit_trend_list_hash_stop.length > 0)) {
            if(twit_trend_list_hash_stop_sorted == false) {
                twit_trend_list_hash_stop.sort(function(first, second) { // 이름-(큰)빈도
                    var comVal = first.localeCompare(second); // 오름차순
                    return comVal;
                }); 
                twit_trend_list_hash_stop_sorted = true;
            }
            var twitHash = twitTrendItem["hash"];
            var stop_inx = twit_trend_list_hash_stop.indexOf(twitHash);
            if(stop_inx >= 0) { // stop-list
                //-console.log("stop-hash : " + twitHash);
                continue;                
            }
        }

        //
        htmTwitItem = makeTwitTrendListHtml_HashTwitItem(twitTrendItem, displayOrder, htmlFormatFalg, copyTextMode,
            list_view_order, list_view_twit_id, list_view_username, list_view_twittext, 
            list_view_detail_hide, list_view_screenname_scratch, list_view_username_scratch,
            userlist_show,
            tweet_ShortUrlReplaceString, tweet_ScratchReplaceString);

        //---
        innerHtm += htmTwitItem;
    }
    if(htmlFormatFalg == true) {
        innerHtm += "</table>";
    }
    else {
    }

    //-console.log(innerHtm + '\r\n');
    return innerHtm;
}

function makeTwitTrendListHtml_HashTwitItem(twitTrendItem, displayOrder, htmlFormatFalg, copyTextMode,
    list_view_order, list_view_twit_id, list_view_username, list_view_twittext, 
    list_view_detail_hide, list_view_screenname_scratch, list_view_username_scratch,
    userlist_show,
    tweet_ShortUrlReplaceString, tweet_ScratchReplaceString) 
{
    //
    var htmTwitTrendItem = " ";
    
    //---------------
    var order = twitTrendItem["order"];
    var twitUserList = twitTrendItem["userlist"];
    var twitHash = twitTrendItem["hash"];
    var twitFreq = twitTrendItem["freq"];

    //-var twitUserID = twitTrendItem["user_id"];
    //-var twitUsername = twitTrendItem["user_name"]
    //-var twitScreenname = twitTrendItem["screen_name"];

    //-----
    //-----
    if(copyTextMode == true) { // copy를 위한 TextMode 일 때
        field_delimiter_string = "\t";
        field_delimiter_string3 = "\t"; // 필드 구분은 탭(\t)문자로만 하기 때문에 1글자만 사용
    }
    else {
        field_delimiter_string = "&nbsp;";
        field_delimiter_string3 = "&nbsp;&nbsp;&nbsp;";
    }

    //---
    //---
    var twitBody = '';

    var goto_hash_twit_anchor = '';
    if(copyTextMode == false) {
        goto_hash_twit_anchor = makeGotoString_Hash(twitHash);
    }
    else {
        goto_hash_twit_anchor = twitHash;
    }

    //---
    //---
    var twit_HashUserlist = '';
    if(twitUserList.length > 0) {
        if(copyTextMode == false) {
            twit_HashUserlist += '   (' + twitUserList.length + ' User)';
        }        
        else {
            twit_HashUserlist += String(twitUserList.length);
            twit_HashUserlist += field_delimiter_string;
        }
    }
    if(userlist_show == true) {
        //---
        //---
        var order_by_freq = true;

        var twitlist_menu_user_freq = document.getElementById('twitlist_menu_user_freq');
        var twitlist_menu_user_name = document.getElementById('twitlist_menu_user_name');
        if((twitlist_menu_user_freq != null) && (twitlist_menu_user_freq.checked)) { // 빈도순
            order_by_freq = true;
        }
        else if((twitlist_menu_user_name != null) && (twitlist_menu_user_name.checked)) { // 이름순
            order_by_freq = false;
        }
        else {
            // 메뉴가 없으면 {빈도순}으로 한다.
            //-alert('logic-error: ');
            //-return innerHtm;
            order_by_freq = true;
        }

        //---
        //---
        if(order_by_freq == true) { // 빈도순
            twitUserList.sort(function(first, second) { // (큰)빈도-이름순
                //-var comVal = first.freq - second.freq; // 올림차순
                var comVal = second.freq - first.freq; // 내림차순
                if(comVal == 0) {
                    comVal = first.user_name.localeCompare(second.user_name); // 오름차순
                }
                return comVal;
            }); 
        }
        else { // 이름순
            twitUserList.sort(function(first, second) { // 이름-(큰)빈도
                //-var comVal = secondx.user_name.localeCompare(second.user_name); // 올림차순
                var comVal = first.user_name.localeCompare(second.user_name); // 오름차순
                if(comVal == 0) {
                    comVal = second.freq - first.freq; // 내림차순
                }
                return comVal;
            }); 
        }
        
        if(twitUserList.length > 0) {
            if(copyTextMode == false) {
                twit_HashUserlist += '<br>';
            }
        }
        for(var usercnt = 0; usercnt < twitUserList.length; usercnt++) {
            //-var hash_user_item = {
            //-    user_id:    twitUserID, 
            //-    user_name:  twitUsername, 
            //-    screen_name:twitScreenname, 
            //-    freq: 1
            //-};
                
            var hash_user_item = twitUserList[usercnt];
            var twitScreenname = hash_user_item.screen_name;
            var twitUsername = hash_user_item.user_name;

            //-----
            //-----
            var twitScreenname_new;
            if(list_view_screenname_scratch == true) {
                var twitScreenname_array = __getSymbols__(twitScreenname);
                twitScreenname_new = twitScreenname_array[0];
                twitScreenname_new += tweet_ScratchReplaceString;
            }
            else {
                twitScreenname_new = twitScreenname;
            }
            var twitUsername_new;
            if(list_view_username_scratch == true) {
                var twitUsername_array = __getSymbols__(twitUsername);
                twitUsername_new = twitUsername_array[0];
                twitUsername_new += tweet_ScratchReplaceString;
            }
            else {
                twitUsername_new = twitUsername;
            }
            //-----
            //- goto user : format - https://twitter.com/{Screenname}
            //-----
            var goto_anchor = '';
            if(copyTextMode == false) {
                goto_anchor = makeGotoString_User(twitScreenname, twitScreenname_new, twitUsername_new);
                twit_HashUserlist += '[' + hash_user_item.freq + '회] ';
            }
            else {
                goto_anchor = twitUsername_new + '@' + twitScreenname_new;
                twit_HashUserlist += String(hash_user_item.freq);
                twit_HashUserlist += "  ";
            }
            twit_HashUserlist += goto_anchor;
            twit_HashUserlist += "  ";
        }
    }
    
    //-----
    //-----
    displayOrder = order;
    if(htmlFormatFalg == true) {
        htmTwitTrendItem += "<tr>";

        //
        if(list_view_order == true) {
            htmTwitTrendItem += "<td width=60>" + displayOrder + "</td>";
        }

        //
        if(list_view_twit_id == true) {
            //-htmTwitTrendItem += "<td width=100>" + twitID + "</td>";
        }

        //
        htmTwitTrendItem += "<td ";
        htmTwitTrendItem += " width=47 ";
        htmTwitTrendItem += ">" + twitFreq + "</td>";

        //
        htmTwitTrendItem += "<td style='text-align: left;'>";
        //-htmTwitTrendItem += twitHash;
        htmTwitTrendItem += goto_hash_twit_anchor;
        htmTwitTrendItem += twit_HashUserlist;
        htmTwitTrendItem += "</td>";

        //
        htmTwitTrendItem += "</tr>";
    }
    else {
        if(copyTextMode == false) {
            htmTwitTrendItem += "<div id='TwitListTable_Div' >";
        }

        //
        if(list_view_order == true) {
            htmTwitTrendItem += displayOrder + field_delimiter_string;
        }

        //
        if(list_view_twit_id == true) {
            if(copyTextMode == false) {
                //-htmTwitTrendItem += "(" + twiID + ")" + field_delimiter_string;
            }
            else {
                //-htmTwitTrendItem += twiID + field_delimiter_string;
            }
        }

        //
        if(copyTextMode == false) {
            htmTwitTrendItem += twitFreq + " (회) ";
        }
        else {
            htmTwitTrendItem += twitFreq;
        }
        htmTwitTrendItem += field_delimiter_string;

        //
        //-htmTwitTrendItem += twitHash;
        htmTwitTrendItem += goto_hash_twit_anchor;
        htmTwitTrendItem += field_delimiter_string;
        
        //
        htmTwitTrendItem += twit_HashUserlist;
        htmTwitTrendItem += field_delimiter_string;

        //
        if(copyTextMode == false) {
            htmTwitTrendItem += "</div>";
        }
        else {
            htmTwitTrendItem += "\r\n";
        }

        //
        //-htmTwitTrendItem += "<div id='TwitListTableGab_Div' ></div>";
    }

    //-console.log(htmTwitTrendItem + '\r\n');
    return htmTwitTrendItem;
}

function makeTwitTrendListHtml_Time(twit_trend_list, copyTextMode = false) 
{
    //
    var innerHtm = "";

    //---
    //---
    var timelist_show = false;
    var btn_user_timelist_show = document.getElementById('btn_twitlist_view_user_timelist_show');
    if((btn_user_timelist_show != null) && (btn_user_timelist_show.checked)) {
        timelist_show = true;
    }
    
    //
    var order_by_freq = true;

    var twitlist_menu_time_freq = document.getElementById('twitlist_menu_time_freq');
    var twitlist_menu_time_date = document.getElementById('twitlist_menu_time_date');
    if((twitlist_menu_time_freq != null) && (twitlist_menu_time_freq.checked)) { // 빈도순
        order_by_freq = true;
    }
    else if((twitlist_menu_time_date != null) && (twitlist_menu_time_date.checked)) { // time순
        order_by_freq = false;
    }
    else {
        // 메뉴가 없으면 {빈도순}으로 한다.
        //-alert('logic-error: ');
        //-return innerHtm;
        order_by_freq = true;
    }

    if(order_by_freq == true) { // 빈도순
        twit_trend_list.sort(function(first, second) { // (큰)빈도-time순
            //-var comVal = first.freq - second.freq; // 올림차순
            var comVal = second.freq - first.freq; // 내림차순
            if(comVal == 0) {
                comVal = first.time_millisec - second.time_millisec; // 오름차순
            }
            return comVal;
        }); 
    }
    else { // time순
        twit_trend_list.sort(function(first, second) { // time-(큰)빈도
            var comVal = second.time_millisec - first.time_millisec; // 내림차순
            //-var comVal = first.time_millisec - second.time_millisec; // 올림차순
            if(comVal == 0) {
                comVal = second.freq - first.freq; // 내림차순
            }
            return comVal;
        }); 
    }

    //---------------
    //-var htmlFormatFalg = true;
    var htmlFormatFalg = false;
    var twitText_newline_flag = true;
    //-var twitText_newline_flag = false;
    var tweet_ShortUrlReplaceString = '🔗';
    var tweet_ScratchReplaceString = '*******'

    var by_tweet_ShortUrlReplaceString = document.getElementById('tweet_ShortUrlReplaceString');
    if(by_tweet_ShortUrlReplaceString != null) {
        if(by_tweet_ShortUrlReplaceString.value.length > 0) {
            tweet_ShortUrlReplaceString = by_tweet_ShortUrlReplaceString.value;
        }
    }
    var by_tweet_ScratchReplaceString = document.getElementById('tweet_ScratchReplaceString');
    if(by_tweet_ScratchReplaceString != null) {
        if(by_tweet_ScratchReplaceString.value.length > 0) {
            tweet_ScratchReplaceString = by_tweet_ScratchReplaceString.value;
        }
    }
    var by_tweet_list_view_html_format = document.getElementById('tweet_list_view_html_format');
    if(by_tweet_list_view_html_format != null) {
        var tweet_list_view_html_format = String(by_tweet_list_view_html_format.value);
        if(tweet_list_view_html_format === '1') {
            htmlFormatFalg = true;
        }
        if(tweet_list_view_html_format === 'true') {
            htmlFormatFalg = true;
        }
    }
    if(copyTextMode == true) { // copy를 위한 텍스트일 때에는 html 태그를 만들지 않는다.
        htmlFormatFalg = false;
    }
    var list_view_detail_hide = false;
    var by_tweet_list_view_detail_hide = document.getElementById('tweet_list_view_detail_hide');
    if(by_tweet_list_view_detail_hide != null) {
        var tweet_list_view_detail_hide = String(by_tweet_list_view_detail_hide.value);
        if(tweet_list_view_detail_hide === '1') {
            list_view_detail_hide = true;
        }
        if(tweet_list_view_detail_hide === 'true') {
            list_view_detail_hide = true;
        }
    }

    if(htmlFormatFalg == true) {
        twitText_newline_flag = false;
    }

    //
    if(twit_trend_list.length <= 0) { // 출력할 게 없는 경우
        return innerHtm;
    }

    // 목록 출력 최댓값 확인
    var list_view_max = 0;
    var twit_list_view_max = document.getElementById('tweet_list_view_max');
    if(twit_list_view_max != null) {
        list_view_max = parseInt(twit_list_view_max.value);
    }
    var list_view_order = false;
    var twit_list_view_order = document.getElementById('btn_tweet_list_view_order');
    if((twit_list_view_order != null) &&
        (twit_list_view_order.checked)) {
        list_view_order = true;
    }
    var list_view_twit_id = false;
    var twit_list_view_twit_id = document.getElementById('btn_tweet_list_view_twit_id');
    if((twit_list_view_twit_id != null) &&
        (twit_list_view_twit_id.checked)) {
        list_view_twit_id = true;
    }
    var list_view_username = false;
    var twit_list_view_username = document.getElementById('btn_tweet_list_view_username');
    if(twit_list_view_username != null) {
        if(twit_list_view_username.checked) {
            list_view_username = true;
        }
    }
    var list_view_twittext = false;
    var twit_list_view_twittext = document.getElementById('btn_tweet_list_view_twittext');
    if((twit_list_view_twittext != null) &&
        (twit_list_view_twittext.checked)) {
        list_view_twittext = true;
    }
    var list_view_screenname_scratch = false;
    var twit_list_view_screenname_scratch = document.getElementById('btn_tweet_list_view_screenname_scratch');
    if((twit_list_view_screenname_scratch != null) &&
        (twit_list_view_screenname_scratch.checked)) {
        list_view_screenname_scratch = true;
    }
    var list_view_username_scratch = false;
    var twit_list_view_username_scratch = document.getElementById('btn_tweet_list_view_username_scratch');
    if((twit_list_view_username_scratch != null) &&
        (twit_list_view_username_scratch.checked)) {
        list_view_username_scratch = true;
    }

    //
    if(htmlFormatFalg == true) {
        //-innerHtm += "<table id='TwitListTable_NoBorder' >";
        innerHtm += "<table id='TwitListTable_Border' >";
    }
    else {
    }

    //
    var displayOrder = 0;
    for (var list_inx = 0; list_inx < twit_trend_list.length; list_inx++) {
        displayOrder = (1 + list_inx); // 0-base
        // 목록 출력 최댓값 확인
        if(list_view_max > 0) {
            if(list_inx > list_view_max) {
                break;
            }
        }

        //
        var twitTrendItem = twit_trend_list[list_inx];

        //
        htmTwitItem = makeTwitTrendListHtml_TimeTwitItem(twitTrendItem, displayOrder, htmlFormatFalg, copyTextMode,
            list_view_order, list_view_twit_id, list_view_username, list_view_twittext, 
            list_view_detail_hide, list_view_screenname_scratch, list_view_username_scratch,
            timelist_show, 
            tweet_ShortUrlReplaceString, tweet_ScratchReplaceString);

        //---
        innerHtm += htmTwitItem;
    }
    if(htmlFormatFalg == true) {
        innerHtm += "</table>";
    }
    else {
    }

    //-console.log(innerHtm + '\r\n');
    return innerHtm;
}

function makeTwitTrendListHtml_TimeTwitItem(twitTrendItem, displayOrder, htmlFormatFalg, copyTextMode, 
    list_view_order, list_view_twit_id, list_view_username, list_view_twittext, 
    list_view_detail_hide, list_view_screenname_scratch, list_view_username_scratch,
    timelist_show, 
    tweet_ShortUrlReplaceString, tweet_ScratchReplaceString) 
{
    //
    var htmTwitTrendItem = " ";
    
    //---------------
    var order = twitTrendItem["order"];
    var twitTimeMillisec = twitTrendItem["time_millisec"];
    var twitList = twitTrendItem["twit_list"];
    var twitFreq = twitTrendItem["freq"];

    //-----
    //-----
    if(copyTextMode == true) { // copy를 위한 TextMode 일 때
        field_delimiter_string = "\t";
        field_delimiter_string3 = "\t"; // 필드 구분은 탭(\t)문자로만 하기 때문에 1글자만 사용
    }
    else {
        field_delimiter_string = "&nbsp;";
        field_delimiter_string3 = "&nbsp;&nbsp;&nbsp;";
    }

    //---
    //---
    var twitBody = '';

    var twitTime_value =  new Date(twitTimeMillisec);
    var twitTimeUnit_String = get_tweet_time_string(twitTime_value, true);
    twitBody += twitTimeUnit_String;

    //-----
    //-----
    var twitTimeList = '';
    if(timelist_show == true) {
        if(twitList.length > 0) {
            if(copyTextMode == false) {
                twitTimeList += '<br>';
            }            
        }
        for(var timecnt = 0; timecnt < twitList.length; timecnt++) {
            //-var time_twit_item = {
            //-    twit_id:    twitID,
            //-    twit_time:  twitTime,
            //-    user_id:    twitUserID, 
            //-    user_name:  twitUsername, 
            //-    screen_name:twitScreenname
            //-};
            var time_twit_item = twitList[timecnt];
            var twitScreenname = time_twit_item.screen_name;

            var twitTime_value = new Date(time_twit_item.twit_time);
            var twitTimeString = get_tweet_time_string(twitTime_value, true);
            
            var goto_anchor = '';
            if(copyTextMode == false) {
                goto_anchor = makeGotoString_twitID(twitScreenname, time_twit_item.twit_id, twitTimeString);
            }
            else {
                goto_anchor = twitTimeString;
            }

            //-twitTimeList += twitTimeString;
            twitTimeList += goto_anchor;
            twitTimeList += '  ';
        }
    }
    
    //-----
    //-----
    displayOrder = order;
    if(htmlFormatFalg == true) {
        htmTwitTrendItem += "<tr>";

        //
        if(list_view_order == true) {
            htmTwitTrendItem += "<td width=60>" + displayOrder + "</td>";
        }

        //
        if(list_view_twit_id == true) {
            //-htmTwitTrendItem += "<td width=100>" + twitID + "</td>";
        }

        //
        htmTwitTrendItem += "<td ";
        //-htmTwitTrendItem += " width=47 ";
        htmTwitTrendItem += ">" + twitBody + "</td>";

        //
        htmTwitTrendItem += "<td ";
        htmTwitTrendItem += " width=47 ";
        htmTwitTrendItem += ">" + twitFreq + "</td>";

        //
        htmTwitTrendItem += "<td style='text-align: left;'>";
        htmTwitTrendItem += twitTimeList;
        htmTwitTrendItem += "</td>";

        //
        htmTwitTrendItem += "</tr>";
    }
    else {
        if(copyTextMode == false) {
            htmTwitTrendItem += "<div id='TwitListTable_Div' >";
        }

        //
        if(list_view_order == true) {
            htmTwitTrendItem += displayOrder + field_delimiter_string;
        }

        //
        if(list_view_twit_id == true) {
            if(copyTextMode == false) {
                //-htmTwitTrendItem += "(" + twitID + ")" + field_delimiter_string;
            }
            else {
                //-htmTwitTrendItem += twitID + field_delimiter_string;
            }
        }

        //
        htmTwitTrendItem += twitBody;
        htmTwitTrendItem += field_delimiter_string3;

        //
        if(copyTextMode == false) {
            htmTwitTrendItem += twitFreq + " (회) ";
        }
        else {
            htmTwitTrendItem += twitFreq;
        }
        htmTwitTrendItem += field_delimiter_string3;

        //
        htmTwitTrendItem += twitTimeList;

        //
        if(copyTextMode == false) {
            htmTwitTrendItem += "</div>";
        }
        else {
            htmTwitTrendItem += "\r\n";
        }

        //
        //-htmTwitTrendItem += "<div id='TwitListTableGab_Div' ></div>";
    }

    //-console.log(htmTwitTrendItem + '\r\n');
    return htmTwitTrendItem;
}

function makeTwitTrendListHtml_TimeCycle(twit_trend_list, copyTextMode = false) 
{
    //
    var innerHtm = "";

    //---
    //---
    var timelist_show = false;
    var btn_user_timelist_show = document.getElementById('btn_twitlist_view_user_timelist_show');
    if((btn_user_timelist_show != null) && (btn_user_timelist_show.checked)) {
        timelist_show = true;
    }
    
    //
    var order_by_freq = true;

    var twitlist_menu_time_freq = document.getElementById('twitlist_menu_time_freq');
    var twitlist_menu_time_date = document.getElementById('twitlist_menu_time_date');
    if((twitlist_menu_time_freq != null) && (twitlist_menu_time_freq.checked)) { // 빈도순
        order_by_freq = true;
    }
    else if((twitlist_menu_time_date != null) && (twitlist_menu_time_date.checked)) { // time순
        order_by_freq = false;
    }
    else {
        // 메뉴가 없으면 {빈도순}으로 한다.
        //-alert('logic-error: ');
        //-return innerHtm;
        order_by_freq = true;
    }

    if(order_by_freq == true) { // 빈도순
        twit_trend_list.sort(function(first, second) { // (큰)빈도-time순
            //-var comVal = first.freq - second.freq; // 올림차순
            var comVal = second.freq - first.freq; // 내림차순
            if(comVal == 0) {
                comVal = first.time_cycle - second.time_cycle; // 오름차순
            }
            return comVal;
        }); 
    }
    else { // time순
        twit_trend_list.sort(function(first, second) { // time-(큰)빈도
            var comVal = second.time_cycle - first.time_cycle; // 내림차순
            //-var comVal = first.time_cycle - second.time_cycle; // 올림차순
            if(comVal == 0) {
                comVal = second.freq - first.freq; // 내림차순
            }
            return comVal;
        }); 
    }

    //---------------
    //-var htmlFormatFalg = true;
    var htmlFormatFalg = false;
    var twitText_newline_flag = true;
    //-var twitText_newline_flag = false;
    var tweet_ShortUrlReplaceString = '🔗';
    var tweet_ScratchReplaceString = '*******'

    var by_tweet_ShortUrlReplaceString = document.getElementById('tweet_ShortUrlReplaceString');
    if(by_tweet_ShortUrlReplaceString != null) {
        if(by_tweet_ShortUrlReplaceString.value.length > 0) {
            tweet_ShortUrlReplaceString = by_tweet_ShortUrlReplaceString.value;
        }
    }
    var by_tweet_ScratchReplaceString = document.getElementById('tweet_ScratchReplaceString');
    if(by_tweet_ScratchReplaceString != null) {
        if(by_tweet_ScratchReplaceString.value.length > 0) {
            tweet_ScratchReplaceString = by_tweet_ScratchReplaceString.value;
        }
    }
    var by_tweet_list_view_html_format = document.getElementById('tweet_list_view_html_format');
    if(by_tweet_list_view_html_format != null) {
        var tweet_list_view_html_format = String(by_tweet_list_view_html_format.value);
        if(tweet_list_view_html_format === '1') {
            htmlFormatFalg = true;
        }
        if(tweet_list_view_html_format === 'true') {
            htmlFormatFalg = true;
        }
    }
    if(copyTextMode == true) { // copy를 위한 텍스트일 때에는 html 태그를 만들지 않는다.
        htmlFormatFalg = false;
    }
    var list_view_detail_hide = false;
    var by_tweet_list_view_detail_hide = document.getElementById('tweet_list_view_detail_hide');
    if(by_tweet_list_view_detail_hide != null) {
        var tweet_list_view_detail_hide = String(by_tweet_list_view_detail_hide.value);
        if(tweet_list_view_detail_hide === '1') {
            list_view_detail_hide = true;
        }
        if(tweet_list_view_detail_hide === 'true') {
            list_view_detail_hide = true;
        }
    }

    if(htmlFormatFalg == true) {
        twitText_newline_flag = false;
    }

    //
    if(twit_trend_list.length <= 0) { // 출력할 게 없는 경우
        return innerHtm;
    }

    // 목록 출력 최댓값 확인
    var list_view_max = 0;
    var twit_list_view_max = document.getElementById('tweet_list_view_max');
    if(twit_list_view_max != null) {
        list_view_max = parseInt(twit_list_view_max.value);
    }
    var list_view_order = false;
    var twit_list_view_order = document.getElementById('btn_tweet_list_view_order');
    if((twit_list_view_order != null) &&
        (twit_list_view_order.checked)) {
        list_view_order = true;
    }
    var list_view_twit_id = false;
    var twit_list_view_twit_id = document.getElementById('btn_tweet_list_view_twit_id');
    if((twit_list_view_twit_id != null) &&
        (twit_list_view_twit_id.checked)) {
        list_view_twit_id = true;
    }
    var list_view_username = false;
    var twit_list_view_username = document.getElementById('btn_tweet_list_view_username');
    if(twit_list_view_username != null) {
        if(twit_list_view_username.checked) {
            list_view_username = true;
        }
    }
    var list_view_twittext = false;
    var twit_list_view_twittext = document.getElementById('btn_tweet_list_view_twittext');
    if((twit_list_view_twittext != null) &&
        (twit_list_view_twittext.checked)) {
        list_view_twittext = true;
    }
    var list_view_screenname_scratch = false;
    var twit_list_view_screenname_scratch = document.getElementById('btn_tweet_list_view_screenname_scratch');
    if((twit_list_view_screenname_scratch != null) &&
        (twit_list_view_screenname_scratch.checked)) {
        list_view_screenname_scratch = true;
    }
    var list_view_username_scratch = false;
    var twit_list_view_username_scratch = document.getElementById('btn_tweet_list_view_username_scratch');
    if((twit_list_view_username_scratch != null) &&
        (twit_list_view_username_scratch.checked)) {
        list_view_username_scratch = true;
    }

    //
    if(htmlFormatFalg == true) {
        //-innerHtm += "<table id='TwitListTable_NoBorder' >";
        innerHtm += "<table id='TwitListTable_Border' >";
    }
    else {
    }

    //
    var displayOrder = 0;
    for (var list_inx = 0; list_inx < twit_trend_list.length; list_inx++) {
        displayOrder = (1 + list_inx); // 0-base
        // 목록 출력 최댓값 확인
        if(list_view_max > 0) {
            if(list_inx > list_view_max) {
                break;
            }
        }

        //
        var twitTrendItem = twit_trend_list[list_inx];

        //
        htmTwitItem = makeTwitTrendListHtml_TimeCycleItem(twitTrendItem, displayOrder, htmlFormatFalg, copyTextMode,
            list_view_order, list_view_twit_id, list_view_username, list_view_twittext, 
            list_view_detail_hide, list_view_screenname_scratch, list_view_username_scratch,
            timelist_show, 
            tweet_ShortUrlReplaceString, tweet_ScratchReplaceString);

        //---
        innerHtm += htmTwitItem;
    }
    if(htmlFormatFalg == true) {
        innerHtm += "</table>";
    }
    else {
    }

    //-console.log(innerHtm + '\r\n');
    return innerHtm;
}

function makeTwitTrendListHtml_TimeCycleItem(twitTrendItem, displayOrder, htmlFormatFalg, copyTextMode,
    list_view_order, list_view_twit_id, list_view_username, list_view_twittext, 
    list_view_detail_hide, list_view_screenname_scratch, list_view_username_scratch,
    timelist_show, 
    tweet_ShortUrlReplaceString, tweet_ScratchReplaceString) 
{
    //
    var htmTwitTrendItem = " ";
    
    //---------------
    var order = twitTrendItem["order"];
    var twitTimeCycle = twitTrendItem["time_cycle"];
    var twitList = twitTrendItem["twit_list"];
    var twitFreq = twitTrendItem["freq"];

    //-----
    //-----
    if(copyTextMode == true) { // copy를 위한 TextMode 일 때
        field_delimiter_string = "\t";
        field_delimiter_string3 = "\t"; // 필드 구분은 탭(\t)문자로만 하기 때문에 1글자만 사용
    }
    else {
        field_delimiter_string = "&nbsp;";
        field_delimiter_string3 = "&nbsp;&nbsp;&nbsp;";
    }

    //---
    //---
    var twitBody = '';

    //-var twitTime_value =  new Date(twitTimeMillisec);
    //-var twitTimeUnit_String = get_tweet_time_string(twitTime_value, true);
    twitTimeUnit_String = twitTimeCycle;
    twitBody += twitTimeUnit_String;

    //-----
    //-----
    var twitTimeList = '';
    if(timelist_show == true) {
        if(twitList.length > 0) {
            if(copyTextMode == false) {
                twitTimeList += '<br>';
            }
        }
        for(var timecnt = 0; timecnt < twitList.length; timecnt++) {
            //-var time_twit_item = {
            //-    twit_id:    twitID,
            //-    twit_time:  twitTime,
            //-    user_id:    twitUserID, 
            //-    user_name:  twitUsername, 
            //-    screen_name:twitScreenname
            //-};
            var time_twit_item = twitList[timecnt];
            var twitScreenname = time_twit_item.screen_name;

            var twitTime_value = new Date(time_twit_item.twit_time);
            var twitTimeString = get_tweet_time_string(twitTime_value, true);
            
            var goto_anchor = '';
            if(copyTextMode == false) {
                goto_anchor = makeGotoString_twitID(twitScreenname, time_twit_item.twit_id, twitTimeString);
            }
            else {
                goto_anchor = twitTimeString;
            }

            //-twitTimeList += twitTimeString;
            twitTimeList += goto_anchor;
            twitTimeList += '  ';

            
        }
    }
    
    //-----
    //-----
    displayOrder = order;
    if(htmlFormatFalg == true) {
        htmTwitTrendItem += "<tr>";

        //
        if(list_view_order == true) {
            htmTwitTrendItem += "<td width=60>" + displayOrder + "</td>";
        }

        //
        if(list_view_twit_id == true) {
            //-htmTwitTrendItem += "<td width=100>" + twitID + "</td>";
        }

        //
        htmTwitTrendItem += "<td ";
        //-htmTwitTrendItem += " width=47 ";
        htmTwitTrendItem += ">" + twitBody + "</td>";

        //
        htmTwitTrendItem += "<td ";
        htmTwitTrendItem += " width=47 ";
        htmTwitTrendItem += ">" + twitFreq + "</td>";

        //
        htmTwitTrendItem += "<td style='text-align: left;'>";
        htmTwitTrendItem += twitTimeList;
        htmTwitTrendItem += "</td>";

        //
        htmTwitTrendItem += "</tr>";
    }
    else {
        if(copyTextMode == false) {
            htmTwitTrendItem += "<div id='TwitListTable_Div' >";
        }

        //
        if(list_view_order == true) {
            htmTwitTrendItem += displayOrder + field_delimiter_string;
        }

        //
        if(list_view_twit_id == true) {
            if(copyTextMode == false) {
                //-htmTwitTrendItem += "(" + twitID + ")" + field_delimiter_string;
            }
            else {
                //-htmTwitTrendItem += twitID + field_delimiter_string;
            }
        }

        //
        htmTwitTrendItem += twitBody;
        htmTwitTrendItem += field_delimiter_string3;

        //
        if(copyTextMode == false) {
            htmTwitTrendItem += twitFreq + " (회) ";
        }
        else {
            htmTwitTrendItem += twitFreq;
        }
        htmTwitTrendItem += field_delimiter_string3;

        //
        htmTwitTrendItem += twitTimeList;

        //
        if(copyTextMode == false) {
            htmTwitTrendItem += "</div>";
        }
        else {
            htmTwitTrendItem += "\r\n";
        }

        //
        //-htmTwitTrendItem += "<div id='TwitListTableGab_Div' ></div>";
    }

    //-console.log(htmTwitTrendItem + '\r\n');
    return htmTwitTrendItem;
}

function save_twit_trendlist()
{
    // init
    var TwitTrendListText = '';
    var txtFile = "trendlist";
    var copyTextMode = true;

    //
    var twitlist_menu_cmd = get_twitlist_menu_command();
    if(twitlist_menu_cmd === 'tweet') {
        var beginCnt = 0;
        //-TwitTrendListText = makeTwitListHtml(twit_timeline_list_worker, beginCnt, copyTextMode);
        TwitTrendListText = makeTwitListHtml(twit_timeline_list_all, beginCnt, copyTextMode);
        //-console.log(TwitTrendListText);
        txtFile += "_twit";
    }
    else if(twitlist_menu_cmd === 'user') {
        TwitTrendListText = makeTwitTrendListHtml_User(twit_trend_list_user, copyTextMode);
        txtFile += "_user";
    }
    else if(twitlist_menu_cmd === 'hash') {
        TwitTrendListText = makeTwitTrendListHtml_Hash(twit_trend_list_hash, copyTextMode);
        txtFile += "_hash";
    }
    else if(twitlist_menu_cmd === 'time') {
        TwitTrendListText = makeTwitTrendListHtml_Time(twit_trend_list_time, copyTextMode);
        txtFile += "_time";
    }
    else if(twitlist_menu_cmd === 'timecycle') {
        TwitTrendListText = makeTwitTrendListHtml_TimeCycle(twit_trend_list_timecycle, copyTextMode);
        txtFile += "_timecycle";
    }
    else {
        alert('logic-error : ' + 'get_twitlist_menu_command()');
    }

    //
    var tweet_date_worker = get_tweet_date_worker();
    if(tweet_date_worker.length != 8) {
        alert('error : (tweet_date_worker.length != 8)');
        return false;
    }
    var date_worker_year = tweet_date_worker.slice(0, 4);
    var date_worker_month = tweet_date_worker.slice(4, 6);
    var date_worker_day = tweet_date_worker.slice(6, 8);
    txtFile += "_";
    txtFile += tweet_date_worker;

    //
    if(TwitTrendListText.length > 0) {
        //-copy_clipboard(TwitTrendListText);
        txtFile += ".txt";
        saveAsFile(TwitTrendListText, txtFile);
        //-alert('download : ' + txtFile);
    }
}

