﻿function set_ById_info(infoString, ElementById, coloredTextFlag = false, colorValue = '') {
    if (document.getElementById(ElementById) != null) {
        document.getElementById(ElementById).value = infoString;
    }

    //---
    var disp_ElementById = 'disp_' + ElementById;
    if (document.getElementById(disp_ElementById) == null) {
        if (document.getElementById(ElementById) == null) {
            // 두 변수 모두 {null}이면 프로그램 설계에 문제가 있으므로 반드시 고쳐야 한다.
            alert('error: (disp_ElementById == null) && (ElementById == null)');
        }
        return;
    }

    var color_string = '';
    if (coloredTextFlag == true) {
        var color_set = 'blue';
        if (colorValue.length > 0) {
            color_set = colorValue;
        }
        color_string = makeColorTagString(infoString, color_set);
    } else {
        color_string = infoString;
    }
    document.getElementById(disp_ElementById).innerHTML = color_string;
}

function set_ById_info_time(tweet_id_time, ElementById) {
    if (document.getElementById(ElementById) != null) {
        document.getElementById(ElementById).value = tweet_id_time;
    }

    var disp_ElementById = 'disp_' + ElementById;
    if (document.getElementById(disp_ElementById) != null) {
        var time_string = get_date_string(tweet_id_time);
        document.getElementById(disp_ElementById).innerHTML = time_string;
    }
}

function get_tweet_time_string(time_value, shortType = false) {
    var time_string_short = '';

    var time_month = String((time_value.getMonth() + 1));
    var time_date = String(time_value.getDate());
    var time_hour = String(time_value.getHours());
    var time_min = String(time_value.getMinutes());
    var time_sec = String(time_value.getSeconds());

    if (time_month.length <= 1) { // 2자리로 맞춘다.
        time_month = '0' + time_month;
    }
    if (time_date.length <= 1) { // 2자리로 맞춘다.
        time_date = '0' + time_date;
    }
    if (time_hour.length <= 1) { // 2자리로 맞춘다.
        time_hour = '0' + time_hour;
    }
    if (time_min.length <= 1) { // 2자리로 맞춘다.
        time_min = '0' + time_min;
    }
    if (time_sec.length <= 1) { // 2자리로 맞춘다.
        time_sec = '0' + time_sec;
    }
    var time_string_short = time_hour + ':' + time_min + ':' + time_sec;

    if (shortType == true) {
        var time_current = new Date();
        if (time_value.getFullYear() == time_current.getFullYear()) {
            if (time_value.getMonth() == time_current.getMonth()) {
                if (time_value.getDate() == time_current.getDate()) { // {년월일}같으면 생략
                    return time_string_short;
                }
            }

            //
            time_string =
                time_month + '. ' +
                time_date + '. ' +
                time_string_short;
            return time_string;
        }
    }

    //
    time_string = time_value.getFullYear() + '. ' +
        time_month + '. ' +
        time_date + '. ' +
        time_string_short;
    return time_string;
}

function makeTwitText_ShortUrlButton(TwitText, ShortReplaceString) {
    //- https://t.co/6upRTVfObe 트윗 간략 주소를 바꾸기
    //  {https://t.co/}다음에 영문-숫자조합 10자리다

    //-var tmp_text = "";

    var replaceString = '🔗';
    //-var replaceString = 'Go';
    //-var replaceString_Underline = true;
    //-var replaceString_Bold = true;

    var replaceString_Underline = false;
    var replaceString_Bold = false;
    var replaceString_Color = 'red';

    if (ShortReplaceString != null) {
        if (ShortReplaceString.length > 0) {
            replaceString = ShortReplaceString;
        }
    }

    //---
    //---
    var twitTextFindObj = {
        text: TwitText,
        pos_begin: 0,
        find_pos: -1,
        find_len: 0
    };

    var find_begin = 0;
    var TwitText_Replace = '';
    var subEndPos, subString, twitReplace, twitReplace_EndPod;
    var twitReplace_tooltip = '';
    while (find_begin < twitTextFindObj.text.length) {
        findTwitText_ShortUrlPos(twitTextFindObj);
        if ((twitTextFindObj.find_pos >= 0) && (twitTextFindObj.find_len > 0)) {
            // 찾은 곳의 [이전 부분]
            subString = twitTextFindObj.text.slice(twitTextFindObj.pos_begin, twitTextFindObj.find_pos);
            TwitText_Replace += subString;

            // 찾은 부분(임시로 트윗 간략 주소는 생략)
            twitReplace_EndPod = twitTextFindObj.find_pos + twitTextFindObj.find_len;
            twitReplace = twitTextFindObj.text.slice(twitTextFindObj.find_pos, twitReplace_EndPod);

            //--twitReplace_tooltip = makeTooltip_Text(replaceString, replaceString_Color, twitReplace, replaceString_Underline, replaceString_Bold);

            var goto_anchor = makeAnchorString(twitReplace, replaceString, '_tco_twit', twitReplace);
            twitReplace_tooltip += goto_anchor;

            TwitText_Replace += twitReplace_tooltip;

            // 처리된 길이를 계산해준다.
            find_begin = twitTextFindObj.find_pos + twitTextFindObj.find_len;

            // 찾을 길이 조정
            twitTextFindObj.pos_begin = find_begin;
            twitTextFindObj.find_pos = (-1);
            twitTextFindObj.find_len = 0;

        } else {
            subEndPos = twitTextFindObj.text.length;
            subString = twitTextFindObj.text.slice(twitTextFindObj.pos_begin, subEndPos);

            TwitText_Replace += subString;
            find_begin += subString.length;
        }
    }
    //-alert(twitTextFindObj.text);
    //-alert(TwitText_Replace);
    return TwitText_Replace;
}

function makeTooltip_Text(displayText, displayTextColor, tooltipText, underline = false, boldflag = false) {
    // 
    var Tooltip_Text = '';

    Tooltip_Text += '<font color=' + displayTextColor + '>';
    if ((boldflag != undefined) && (boldflag == true)) {
        Tooltip_Text += '<b>';
    }
    if ((underline != undefined) && (underline == true)) {
        Tooltip_Text += '<u>';
    }
    Tooltip_Text += "<span data-tooltip='" + tooltipText + "'>";
    Tooltip_Text += displayText;
    Tooltip_Text += "</span>";
    if ((boldflag != undefined) && (boldflag == true)) {
        Tooltip_Text += '</b>';
    }
    if ((underline != undefined) && (underline == true)) {
        Tooltip_Text += '</u>';
    }
    Tooltip_Text += '</font>';

    return Tooltip_Text;
}

function findTwitText_ShortUrlPos(twitTextFindObj) {
    //-----
    //- https://t.co/6upRTVfObe 트윗 간략 주소를 바꾸기
    //  {https://t.co/}다음에 영문-숫자조합 10자리다
    //-----
    //- twit_short_url_head = 'https://t.co/';
    var TwitText_ShortUrl = ' ';

    if (twitTextFindObj.pos_begin < 0) {
        twitTextFindObj.pos_begin = 0;
    }
    twitTextFindObj.find_pos = twitTextFindObj.text.indexOf(twit_short_url_head, twitTextFindObj.pos_begin);
    if (twitTextFindObj.find_pos < 0) {
        return false;
    }

    //---
    //-newFind_pos = twitTextFindObj.text.indexOf(' ', twitTextFindObj.find_pos); // {https://t.co/}다음에 영문-숫자조합 10자리라서 space로 찾으면 안 된다.

    var newFind_pos = (-1);
    var findBeginPos = (twit_short_url_head.length + twitTextFindObj.find_pos);
    var loopcnt = findBeginPos;
    while (loopcnt < twitTextFindObj.text.length) {
        var curChar = twitTextFindObj.text.charAt(loopcnt);
        if (isAlphaNumer(curChar) == false) {
            break;
        }
        //
        loopcnt++;
        newFind_pos = loopcnt;
    }
    if (newFind_pos < 0) {
        newFind_pos = twitTextFindObj.text.length;
    } else if (newFind_pos != (findBeginPos + 10)) {
        // {https://t.co/}다음에 영문-숫자조합 10자리라서 다를 경우 트윗 단축 주소가 아니다.
        // 나중에 바뀔 수도 있지만 사용자 입력으로 인한 주소 계산 오류를 막기위해 
        // 무조건 길이를 '10'으로 맞춰둔다.
        return false;
    }

    //
    twitTextFindObj.find_len = newFind_pos - twitTextFindObj.find_pos;

    return true;
}

var _Base64_ = {
    _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    encode: function(input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = _Base64_._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output + this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) + this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },


    decode: function(input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = _Base64_._utf8_decode(output);

        return output;

    },

    _utf8_encode: function(string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    _utf8_decode: function(utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while (i < utftext.length) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

}

function get_redate(datetime_value) {
    var datetime_value_new = rebuild_date_tring(datetime_value);
    var datetime_new = new Date(datetime_value_new);
    return datetime_new;
}

function get_date_string(datetime_value) {
    var datetime_new = get_redate(datetime_value);
    var time_string = get_tweet_time_string(datetime_new);
    return time_string;
}

function rebuild_date_tring(korean_date_tring) {
    //-----
    // {Sat Apr 07 2018 14:39:55 GMT 0900 (대한민국 표준시)} 값을 new Date()함수에 넣으면 
    // {Sat Apr 07 2018 23:39:55 GMT+0900 (대한민국 표준시)}로 오게 되는데 
    // 잘못된 것이다. {대한민국 표준시}인데도 9시간을 더해 놓고 여전히 {대한민국 표준시}로 표기하면 
    // 논리적으로 잘못된 것이다. 함수 처리에서 불완전한 것 같다.
    // {GMT 0900 (대한민국 표준시)} 값을 {GMT+0900}로 바꿔서 처리하면 정상으로 처리된다.
    //-----
    var korean_time_label = 'GMT 0900 (대한민국 표준시)';
    var korean_time_pos = (-1);
    if (typeof korean_date_tring === 'string') {
        korean_time_pos = korean_date_tring.indexOf(korean_time_label);
    }
    if (korean_time_pos >= 0) {
        korean_date_tring = korean_date_tring.substr(0, korean_time_pos);
        korean_date_tring += 'GMT+0900';
        korean_date_tring = String(korean_date_tring);
        //-console.log(korean_date_tring);
    }
    //-----
    //-----

    return korean_date_tring;
}

function makeTimeElapseString(time_head, time_tail) {
    // time difference 
    var timeGab = time_head - time_tail;

    // recalc ms unit
    var timeSec = timeGab / 1000;
    // get seconds (Original had 'round' which incorrectly counts 0:28, 0:29, 1:30 ... 1:59, 1:0)
    var seconds = Math.round(timeSec % 60);
    // remove seconds from the date
    timeSec = Math.floor(timeSec / 60);
    // get minutes
    var minutes = Math.round(timeSec % 60);
    // remove minutes from the date
    timeSec = Math.floor(timeSec / 60);
    // get hours
    var hours = Math.round(timeSec % 24);
    // remove hours from the date
    timeSec = Math.floor(timeSec / 24);
    // the rest of timeSec is number of days
    var days = timeSec;

    //
    var elapse_time_string = '';
    if (days > 0) {
        elapse_time_string += days + ' day ';
    }
    if (hours > 0) {
        if (elapse_time_string.length > 0) {
            elapse_time_string += ":";
        }
        elapse_time_string += hours;
    }
    if (minutes > 0) {
        if (elapse_time_string.length > 0) {
            elapse_time_string += ":";
        }
        elapse_time_string += minutes;
    }
    if (seconds >= 0) {
        if (elapse_time_string.length > 0) {
            elapse_time_string += ":";
        }
        elapse_time_string += seconds;
    }
    return elapse_time_string;
}

function makeTwitText_TwitUnitDelimiter(TwitText) {
    // 여러 twit-text를 단위별로 묶을 때 단위를 구분하기 위해서 사용한 
    // 구문문자(__twit_result_field_text_delimiter)를 바꿔준다.

    //-var tmp_text = "";

    var twitTextFindObj = {
        text: TwitText,
        pos_begin: 0,
        find_pos: -1,
        find_len: 0
    };

    var find_begin = 0;
    var TwitText_Replace = '';
    var subEndPos, subString, twitReplace, twitReplace_EndPod;
    while (find_begin < twitTextFindObj.text.length) {
        findTwitText_TwitUnitDelimiter(twitTextFindObj);
        if ((twitTextFindObj.find_pos >= 0) && (twitTextFindObj.find_len > 0)) {
            // 찾은 곳의 [이전 부분]
            subString = twitTextFindObj.text.slice(twitTextFindObj.pos_begin, twitTextFindObj.find_pos);
            TwitText_Replace += subString;

            // 찾은 부분을 {cr-lf}로 변경
            twitReplace_EndPod = twitTextFindObj.find_pos + twitTextFindObj.find_len;
            twitReplace = twitTextFindObj.text.slice(twitTextFindObj.find_pos, twitReplace_EndPod);
            twitReplace_tooltip = '\r\n';
            TwitText_Replace += twitReplace_tooltip;

            // 처리된 길이를 계산해준다.
            find_begin = twitTextFindObj.find_pos + twitTextFindObj.find_len;

            // 찾을 길이 조정
            twitTextFindObj.pos_begin = find_begin;
            twitTextFindObj.find_pos = (-1);
            twitTextFindObj.find_len = 0;

        } else {
            subEndPos = twitTextFindObj.text.length;
            subString = twitTextFindObj.text.slice(twitTextFindObj.pos_begin, subEndPos);

            TwitText_Replace += subString;
            find_begin += subString.length;
        }
    }
    //-alert(twitTextFindObj.text);
    //-alert(TwitText_Replace);
    return TwitText_Replace;
}

function findTwitText_TwitUnitDelimiter(twitTextFindObj) {
    //-----
    // 여러 twit-text를 단위별로 묶을 때 단위를 구분하기 위해서 사용한 
    // 구문문자(__twit_result_field_text_delimiter)를 바꿔준다.
    //-----
    var TwitText_ShortUrl = ' ';

    if (twitTextFindObj.pos_begin < 0) {
        twitTextFindObj.pos_begin = 0;
    }
    twitTextFindObj.find_pos = twitTextFindObj.text.indexOf(__twit_result_field_text_delimiter, twitTextFindObj.pos_begin);
    if (twitTextFindObj.find_pos < 0) {
        return false;
    }
    twitTextFindObj.find_len = __twit_result_field_text_delimiter.length;

    return true;
}

function getDateString_ymd8(Year, Month, Day) { // 8자리 년월일 문자열 만들기
    var year_month_day = '';

    Year = String(Year);
    Month = String(Month);
    Day = String(Day);

    if ((Year.length > 0) && (Year.length <= 4) &&
        (Month.length > 0) && (Month.length <= 2) &&
        (Day.length > 0) && (Day.length <= 2)) {
        if (Year.length <= 1) {
            year_month_day = '200' + year_month_day;
        } else if (Year.length <= 2) {
            year_month_day = '20' + year_month_day;
        } else if (Year.length != 4) { // error-state
            year_month_day = ''; // reset
            return year_month_day;
        }
        year_month_day += Year;

        if (Month.length <= 1) {
            year_month_day = '0' + year_month_day;
        } else if (Month.length != 2) { // error-state
            year_month_day = ''; // reset
            return year_month_day;
        }
        year_month_day += Month;

        if (Day.length <= 1) {
            year_month_day = '0' + year_month_day;
        } else if (Day.length != 2) { // error-state
            year_month_day = ''; // reset
            return year_month_day;
        }
        year_month_day += Day;
    }

    return year_month_day;
}

function compareTwitID(twitID_First, twitID_Second) {
    var copmVal = 0;
    if (typeof twitID_First === 'string') {
        copmVal = twitID_First.localeCompare(twitID_Second);
    } else if (typeof twitID_First === 'number') {
        copmVal = twitID_First.localeCompare(twitID_Second);
    } else {
        alert(' error : (typeof twitID_First)');
    }
    return copmVal;
}

function __getSymbols__(string) { // src: https://mathiasbynens.be/notes/javascript-unicode
    // modify: 20180505
    var index = 0;
    var length = string.length;
    var output = [];
    for (; index < length - 1; ++index) {
        var charCode = string.charCodeAt(index);
        if (charCode >= 0xD800 && charCode <= 0xDBFF) {
            charCode = string.charCodeAt(index + 1);
            if (charCode >= 0xDC00 && charCode <= 0xDFFF) {
                output.push(string.slice(index, index + 2));
                ++index;
                continue;
            }
        }
        output.push(string.charAt(index));
    }
    output.push(string.charAt(index));
    return output;
}

function makeTwitText_ScreenName(TwitText, privacyScratchFlag = false, tweet_ScratchReplaceString = '') {
    // 본문에서 '@~~~' 블록을 바꾼다.

    //-var tmp_text = "";

    var replaceString_Text = '@-------';
    //-var replaceString = '????????';
    //-var replaceString_Underline = true;
    var replaceString_Bold = true;

    var replaceString_Underline = false;
    var replaceString_Bold = false;
    var replaceString_Color = 'blue';

    if (tweet_ScratchReplaceString != null) {
        if (tweet_ScratchReplaceString.length > 0) {
            replaceString_Text = '@' + tweet_ScratchReplaceString;
        }
    }

    //---
    //---
    var twitTextFindObj = {
        text: TwitText,
        pos_begin: 0,
        find_pos: -1,
        find_len: 0
    };

    var find_begin = 0;
    var TwitText_Replace = '';
    var subEndPos, subString, twitReplace, twitReplace_EndPod;
    while (find_begin < twitTextFindObj.text.length) {
        findTwitText_ScreenNamePos(twitTextFindObj);
        if ((twitTextFindObj.find_pos >= 0) && (twitTextFindObj.find_len > 0)) {
            // 찾은 곳의 [이전 부분]
            subString = twitTextFindObj.text.slice(twitTextFindObj.pos_begin, twitTextFindObj.find_pos);
            TwitText_Replace += subString;

            // 찾은 부분()
            twitReplace_EndPod = twitTextFindObj.find_pos + twitTextFindObj.find_len;
            twitReplace = twitTextFindObj.text.slice(twitTextFindObj.find_pos, twitReplace_EndPod); // screenname
            if (privacyScratchFlag != true) {
                replaceString_Text = twitReplace;
            }
            else {
                if (tweet_ScratchReplaceString != null) {
                    if (tweet_ScratchReplaceString.length > 0) {
                        var twitScreenname_array = __getSymbols__(twitReplace); // screenname
                        replaceString_Text = '@';
                        replaceString_Text += twitScreenname_array[1]; // {screenname}은 '@~~~~'이므로 '@'를 제외한 첫 번째 글자는 [1]번이다.
                        replaceString_Text += tweet_ScratchReplaceString; // '----'
                    }
                }
            }

            var colorText = makeColorTagString(replaceString_Text, replaceString_Color);
            TwitText_Replace += colorText;

            // 처리된 길이를 계산해준다.
            find_begin = twitTextFindObj.find_pos + twitTextFindObj.find_len;

            // 찾을 길이 조정
            twitTextFindObj.pos_begin = find_begin;
            twitTextFindObj.find_pos = (-1);
            twitTextFindObj.find_len = 0;

        } else {
            subEndPos = twitTextFindObj.text.length;
            subString = twitTextFindObj.text.slice(twitTextFindObj.pos_begin, subEndPos);

            TwitText_Replace += subString;
            find_begin += subString.length;
        }
    }
    //-alert(twitTextFindObj.text);
    //-alert(TwitText_Replace);
    return TwitText_Replace;
}

function findTwitText_ScreenNamePos(twitTextFindObj) {
    //-----
    //- 본문에서 '@~~~' 영역 찾기(screen-name)
    //-----
    var twit_screen_name_head = '@';
    var TwitText_ShortUrl = ' ';

    if (twitTextFindObj.pos_begin < 0) {
        twitTextFindObj.pos_begin = 0;
    }
    twitTextFindObj.find_pos = twitTextFindObj.text.indexOf(twit_screen_name_head, twitTextFindObj.pos_begin);
    if (twitTextFindObj.find_pos < 0) {
        return false;
    }

    //---
    var newFind_pos = (-1);
    var findBeginPos = (twit_screen_name_head.length + twitTextFindObj.find_pos);
    var loopcnt = findBeginPos;
    while (loopcnt < twitTextFindObj.text.length) {
        var curChar = twitTextFindObj.text.charAt(loopcnt);
        if (isAlphaNumer(curChar) == false) {
            if (curChar != '_') {
                break;
            }
        }
        //
        loopcnt++;
        newFind_pos = loopcnt;
    }
    if (newFind_pos < 0) {
        newFind_pos = twitTextFindObj.text.length;
    }

    //
    twitTextFindObj.find_len = newFind_pos - twitTextFindObj.find_pos;

    return true;
}

function makeTwitText_HashMark(TwitText) {
    // 본문에서 해시태그 '#~~~' 블록을 파란색으로 지정한다.

    //-var tmp_text = "";

    var replaceString_Underline = false;
    var replaceString_Bold = false;
    var replaceString_Color = 'blue';

    //---
    //---
    var twitTextFindObj = {
        text: TwitText,
        pos_begin: 0,
        find_pos: -1,
        find_len: 0
    };

    var find_begin = 0;
    var TwitText_Replace = '';
    var subEndPos, subString, twitReplace, twitReplace_EndPod;
    while (find_begin < twitTextFindObj.text.length) {
        findTwitText_HashPos(twitTextFindObj);
        if ((twitTextFindObj.find_pos >= 0) && (twitTextFindObj.find_len > 0)) {
            // 찾은 곳의 [이전 부분]
            subString = twitTextFindObj.text.slice(twitTextFindObj.pos_begin, twitTextFindObj.find_pos);
            TwitText_Replace += subString;

            // 찾은 부분(색깔을 지정한다.)
            twitReplace_EndPod = twitTextFindObj.find_pos + twitTextFindObj.find_len;
            twitReplace = twitTextFindObj.text.slice(twitTextFindObj.find_pos, twitReplace_EndPod);

            //-var colorText = makeColorTagString(twitReplace, replaceString_Color);
            //-
            //-// hash-address
            //-var twitReplace_NoSharp = twitReplace.slice(1);
            //-var hash_twit_heading = 'https://twitter.com/hashtag/'; // https://twitter.com/hashtag/서울?src=hash
            //-var hash_twit_command = '?src=hash';
            //-var hash_twit_address = hash_twit_heading + twitReplace_NoSharp + hash_twit_command;
            //-
            //-// hash-angchor
            //-var goto_hash_twit_anchor = makeAnchorString(hash_twit_address, colorText, '_hash_twit', twitReplace);
            var goto_hash_twit_anchor = makeGotoString_Hash(twitReplace);

            //-TwitText_Replace += colorText;
            TwitText_Replace += goto_hash_twit_anchor;

            // 처리된 길이를 계산해준다.
            find_begin = twitTextFindObj.find_pos + twitTextFindObj.find_len;

            // 찾을 길이 조정
            twitTextFindObj.pos_begin = find_begin;
            twitTextFindObj.find_pos = (-1);
            twitTextFindObj.find_len = 0;

        } else {
            subEndPos = twitTextFindObj.text.length;
            subString = twitTextFindObj.text.slice(twitTextFindObj.pos_begin, subEndPos);

            TwitText_Replace += subString;
            find_begin += subString.length;
        }
    }
    //-alert(twitTextFindObj.text);
    //-alert(TwitText_Replace);
    return TwitText_Replace;
}

function makeTwitText_Tagify(TwitText) {
    // 본문에서 'tag'로 바꿀 수 있는 블록을 바꾼다.

    //-var tmp_text = "";

    var findString_Text_1 = '\r\n';
    var findString_Text_2 = '\n';

    var replaceString_Tag_1 = '<br>';
    //-var replaceString_Underline = true;
    var replaceString_Bold = true;

    var replaceString_Underline = false;
    var replaceString_Bold = false;
    var replaceString_Color = 'blue';

    //---
    //---
    var pos_begin = 0;
    var find_pos = (-1);
    var find_len = 0;
    var find_begin = 0;
    var TwitText_Replace = '';
    var subEndPos, subString, twitReplace, twitReplace_EndPod;
    while (find_begin < TwitText.length) {
        find_pos = TwitText.indexOf(findString_Text_1, pos_begin);
        if (find_pos >= 0) {
            find_len = findString_Text_1.length;
        } else {
            find_pos = TwitText.indexOf(findString_Text_2, pos_begin);
            if (find_pos >= 0) {
                find_len = findString_Text_2.length;
            }
        }
        if (find_pos >= 0) {
            // 찾은 곳의 [이전 부분]
            subString = TwitText.slice(pos_begin, find_pos);
            TwitText_Replace += subString;

            // 찾은 부분()
            //-twitReplace_EndPod = find_pos + find_len;
            //-twitReplace = TwitText.slice(find_pos, twitReplace_EndPod);
            TwitText_Replace += replaceString_Tag_1;

            // 처리된 길이를 계산해준다.
            find_begin = find_pos + find_len;

            // 찾을 길이 조정
            pos_begin = find_begin;
            find_pos = (-1);
            find_len = 0;
        } else {
            subEndPos = TwitText.length;
            subString = TwitText.slice(pos_begin, subEndPos);

            TwitText_Replace += subString;
            find_begin += subString.length;
        }
    }
    //-alert(TwitText);
    //-alert(TwitText_Replace);
    return TwitText_Replace;
}

function getTwitText_HashMark(TwitText) {
    // 본문에서 해시태그 '#~~~' 블록을 파란색으로 지정한다.

    //-var tmp_text = "";

    var HashMarkArray = [];

    //
    var replaceString_Underline = false;
    var replaceString_Bold = false;
    var replaceString_Color = 'blue';

    //---
    //---
    var twitTextFindObj = {
        text: TwitText,
        pos_begin: 0,
        find_pos: -1,
        find_len: 0
    };

    var find_begin = 0;
    //-var TwitText_Replace = '';
    var subEndPos, subString, twitReplace, twitReplace_EndPod;
    while (find_begin < twitTextFindObj.text.length) {
        //-twitTextFindObj.text = "###감자 "; // "#하루1번👌 ";  // "#봄날http:";
        findTwitText_HashPos(twitTextFindObj);
        if ((twitTextFindObj.find_pos >= 0) && (twitTextFindObj.find_len > 0)) {
            // 찾은 곳의 [이전 부분]
            subString = twitTextFindObj.text.slice(twitTextFindObj.pos_begin, twitTextFindObj.find_pos);
            //-TwitText_Replace += subString;

            // 찾은 부분(색깔을 지정한다.)
            twitReplace_EndPod = twitTextFindObj.find_pos + twitTextFindObj.find_len;
            twitReplace = twitTextFindObj.text.slice(twitTextFindObj.find_pos, twitReplace_EndPod);

            HashMarkArray.push(twitReplace);

            // 처리된 길이를 계산해준다.
            find_begin = twitTextFindObj.find_pos + twitTextFindObj.find_len;

            // 찾을 길이 조정
            twitTextFindObj.pos_begin = find_begin;
            twitTextFindObj.find_pos = (-1);
            twitTextFindObj.find_len = 0;

        } else {
            subEndPos = twitTextFindObj.text.length;
            subString = twitTextFindObj.text.slice(twitTextFindObj.pos_begin, subEndPos);

            //-TwitText_Replace += subString;
            find_begin += subString.length;
        }
    }
    //-alert(twitTextFindObj.text);
    //-alert(TwitText_Replace);

    //
    return HashMarkArray;
}

function makeAnchorString(address, viewText, target = '_blank', title = '') {
    // hash-angchor
    var goto_anchor = '';
    goto_anchor += "<a style='text-decoration: none;' target='" + target + "' href='";
    goto_anchor += address;
    goto_anchor += "' ";
    goto_anchor += " title='" + title + "' ";
    goto_anchor += ">";
    goto_anchor += viewText;
    goto_anchor += "</a>";

    return goto_anchor;
}

function makeGotoString_User(twitScreenname_address, twitScreenname_display, twitUsername = '') {
    //-----
    //- goto user : format - https://twitter.com/{Screenname}
    //-----
    var user_twit_heading = 'https://twitter.com/';
    var user_twit_address = user_twit_heading + twitScreenname_address;

    var goto_title = twitUsername + "@" + twitScreenname_display;
    var goto_anchor = makeAnchorString(user_twit_address, twitUsername, '_user_twit', goto_title);

    return goto_anchor;
}

function makeGotoString_Hash(hashText) {
    var replaceString_Color = 'blue';
    var colorText = makeColorTagString(hashText, replaceString_Color);

    // hash-address
    var hashText_NoSharp = hashText.slice(1);
    var hash_twit_heading = 'https://twitter.com/hashtag/';
    var hash_twit_command = '?src=hash';
    var hash_twit_address = hash_twit_heading + hashText_NoSharp + hash_twit_command;

    // hash-angchor
    var goto_anchor = makeAnchorString(hash_twit_address, colorText, '_hash_twit', hashText);
    return goto_anchor;
}

function makeGotoString_twitID(twitScreenname, twitID, viewText, title = '') {
    //----------
    // 원문 가기: format - https://twitter.com/screenname/status/twit-id
    //----------
    var origin_twit_heading = 'https://twitter.com/';
    var origin_twit_command = '/status/';
    var origin_twit_address = origin_twit_heading + twitScreenname + origin_twit_command + twitID;

    var goto_title = origin_twit_address;
    if (title.length > 0) { // 제목이 있으면 바꿔준다.
        goto_title = title;
    }
    var goto_anchor = makeAnchorString(origin_twit_address, viewText, '_origin_twit', goto_title);

    return goto_anchor;
}

function findTwitText_HashPos(twitTextFindObj) {
    //-----
    //- 본문에서 해시문자열 '#~~~' 영역 찾기
    //-----
    var twit_hash_head = '#';
    var TwitText_ShortUrl = ' ';
    var findBeginPos = (-1);
    var curChar = '';
    var twit_hash_series_state = false;
    var working_pos_begin = 0;

    if (twitTextFindObj.pos_begin < 0) {
        twitTextFindObj.pos_begin = 0;
    }
    working_pos_begin = twitTextFindObj.pos_begin;

    do {
        twitTextFindObj.find_pos = twitTextFindObj.text.indexOf(twit_hash_head, working_pos_begin);
        if (twitTextFindObj.find_pos < 0) {
            return false;
        } else {
            var findBeginPosNext = (twit_hash_head.length + twitTextFindObj.find_pos);
            if (findBeginPosNext < twitTextFindObj.text.length) {
                curChar = twitTextFindObj.text.charAt(findBeginPosNext);
                if (curChar == twit_hash_head) { // '#'문자가 연속인 경우 - '##~' 연속문자는 해시태그가 아니다.
                    working_pos_begin = findBeginPosNext;
                    twit_hash_series_state = true;
                } else {
                    if (twit_hash_series_state == true) {
                        // {##~} 해시문자가 연속이었다면 이 부분 이후부터 다시 찾아야 한다.
                        // 해시문자 '#' 앞에 명확하게 구분되어야 한다.
                        working_pos_begin = findBeginPosNext;
                    } else {
                        twitTextFindObj.pos_begin = working_pos_begin; // 찾은 '#' (해시)문자 위치를 넘긴다.
                        break;
                    }
                }
            } else { // '#'문자 한 개인 경우
                return false;
            }
        }
    } while (true);

    //---
    findBeginPos = (twit_hash_head.length + twitTextFindObj.find_pos);
    var newFind_pos = (-1);
    var honhash_pos = (-1);
    var loopcnt = findBeginPos;
    var curCharCode;
    while (loopcnt < twitTextFindObj.text.length) {
        curChar = twitTextFindObj.text.charAt(loopcnt);
        curCharCode = twitTextFindObj.text.charCodeAt(loopcnt);
        if (isAlphaNumer(curChar) == false) {
            var nonHash = false;
            switch (curChar) {
                case '_':
                    break;

                case ' ':
                case '\t':
                case '\r':
                case '\n':
                case ',':
                case '.':
                case ':':
                case ';':
                case '\'':
                case '"':
                case '[':
                case ']':
                case '{':
                case '}':
                case '<':
                case '>':
                case '~':
                case '`':
                case '!':
                case '@':
                case '#':
                case '%':
                case '^':
                case '&':
                case '*':
                case '(':
                case ')':
                case '-':
                case '+':
                case '=':
                case '|':
                case '\\':
                case '/':
                case '?':

                case '▶':
                case '◀':
                case '■':
                case '▢':
                case '▣':
                case '▤':
                case '▥':
                case '▦':
                case '▧':
                case '▨':
                case '▩':
                case '▪':
                case '▫':
                case '▬':
                case '▭':
                case '▮':
                case '▯':
                case '▰':
                case '▱':
                case '▲':
                case '△':
                case '▴':
                case '▵':
                case '▶':
                case '▷':
                case '▸':
                case '▹':
                case '►':
                case '▻':
                case '▼':
                case '▽':
                case '▾':
                case '▿':
                case '◀':
                case '◁':
                case '◂':
                case '◃':
                case '◄':
                case '◅':
                case '◆':
                case '◇':
                case '◈':
                case '◉':
                case '◊':
                case '○':
                case '◌':
                case '◍':
                case '◎':
                case '●':
                case '◐':
                case '◑':
                case '◒':
                case '◓':
                case '◔':
                case '◕':
                case '◖':
                case '◗':
                case '◘':
                case '◙':
                case '◚':
                case '◛':
                case '◜':
                case '◝':
                case '◞':
                case '◟':
                case '◠':
                case '◡':
                case '◢':
                case '◣':
                case '◤':
                case '◥':
                case '◦':
                case '◧':
                case '◨':
                case '◩':
                case '◪':
                case '◺':
                case '◻':
                case '◼':
                case '◽':
                case '◾':
                case '྿':



                case '…':
                case '’':
                case '«':
                case '»':
                case '‐':
                case '·':
                case '‘':
                case '“':
                case '”':
                case '„':
                case '‹':
                case '›':
                case '‒':
                case '–':
                case '—':
                case '―':
                case '⁄':
                case '「':
                case '」':
                case '『':
                case '』':
                case '‛':
                case '‟':
                case '〟':
                case '〝':

                    nonHash = true;
                    break;
            }
            if (nonHash == true) {
                honhash_pos = loopcnt;
                break;
            } else {
                if (curCharCode > 0xD800) { // emoji-range : is bigger than 0x0xD800 (for emoji it is actually >=0xD836)
                    honhash_pos = loopcnt;
                    break;
                }
            }
        }
        //
        loopcnt++;
        newFind_pos = loopcnt;
    }
    if (newFind_pos < 0) {
        // 
        if ((twitTextFindObj.find_pos + 1) == honhash_pos) {
            return false; // 해시문자 다음에 곧 바로 해시문자열을 구성할 수 없는 문자인 경우 - 그냥 '#'문자만 있는 경우다.
        }
        newFind_pos = twitTextFindObj.text.length;
    }

    // "#~https:", "#~http:" 검사
    if (twitTextFindObj.text.charAt(newFind_pos) == ':') {
        if ((newFind_pos > 0) && (twitTextFindObj.text.charAt(newFind_pos - 1) == 's')) {
            if ((newFind_pos > 1) && (twitTextFindObj.text.charAt(newFind_pos - 2) == 'p')) {
                if ((newFind_pos > 2) && (twitTextFindObj.text.charAt(newFind_pos - 3) == 't')) {
                    if ((newFind_pos > 3) && (twitTextFindObj.text.charAt(newFind_pos - 4) == 't')) {
                        if ((newFind_pos > 4) && (twitTextFindObj.text.charAt(newFind_pos - 5) == 'h')) {
                            newFind_pos -= 5;
                        }
                    }
                }
            }
        } else if ((newFind_pos > 0) && (twitTextFindObj.text.charAt(newFind_pos - 1) == 'p')) {
            if ((newFind_pos > 1) && (twitTextFindObj.text.charAt(newFind_pos - 2) == 't')) {
                if ((newFind_pos > 2) && (twitTextFindObj.text.charAt(newFind_pos - 3) == 't')) {
                    if ((newFind_pos > 3) && (twitTextFindObj.text.charAt(newFind_pos - 4) == 'h')) {
                        newFind_pos -= 4;
                    }
                }
            }
        }
    }

    //
    twitTextFindObj.find_len = newFind_pos - twitTextFindObj.find_pos;

    return true;
}

function transDateUnit_ByMin(timeDate, minUnit) { // timeDate : new Date(time) 이 함수 밖에서 이렇게 선언된 것만 온다고 가정
    //
    var trans_minUnit = 0;

    switch (minUnit) {
        case 1:
        case 2:
        case 3:
        case 4:
        case 5:
        case 6:
        case 10:
        case 12:
        case 15:
        case 20:
        case 30:
            break;
        default:
            var mod_val = minUnit % 60;
            if (mod_val != 0) {
                alert('logic-error: 60분을 나눌 수 있는 값이어야 합니다. ==> ' + minUnit);
                return trans_minUnit;
            }
            break;
    }

    //
    var time_year = timeDate.getFullYear();
    //-var time_month = (timeDate.getMonth() + 1);
    var time_month = timeDate.getMonth();
    var time_date = timeDate.getDate();
    var time_hour = timeDate.getHours();
    var time_min = timeDate.getMinutes();
    //-var time_sec = timeDate.getSeconds();

    var trans_date;

    if (minUnit >= 60) {
        var minUnit_by_hour = parseInt(minUnit / 60);
        var trans_hour_down = parseInt(time_hour / minUnit_by_hour);
        var trans_hour_up = trans_hour_down * minUnit_by_hour;
        trans_date = new Date(time_year, time_month, time_date, trans_hour_up, 0, 0, 0);
    } else {
        var trans_min_down = parseInt(time_min / minUnit);
        var trans_min_up = trans_min_down * minUnit;
        trans_date = new Date(time_year, time_month, time_date, time_hour, trans_min_up, 0, 0);
    }
    trans_minUnit = trans_date.getTime();
    return trans_minUnit;
}

function transDateUnit_ByMinCycle(timeDate, minUnit) { // timeDate : new Date(time) 이 함수 밖에서 이렇게 선언된 것만 온다고 가정
    //
    var trans_minUnit = (-1);

    switch (minUnit) {
        case 1:
        case 2:
        case 3:
        case 4:
        case 5:
        case 6:
        case 10:
        case 12:
        case 15:
        case 20:
        case 30:
            break;
        default:
            alert('logic-error: 1시간을 기준으로 사이클을 찾는 것이므로 60분을 나눌 수 있는 값이어야 합니다. ==> ' + minUnit);
            return trans_minUnit;
    }

    //
    //-var time_year = timeDate.getFullYear();
    //-var time_month = (timeDate.getMonth() + 1);
    //-var time_date = timeDate.getDate();
    //-var time_hour = timeDate.getHours();
    var time_min = timeDate.getMinutes();
    //-var time_sec = timeDate.getSeconds();

    var trans_min_down = parseInt(time_min / minUnit);
    var trans_min_up = trans_min_down * minUnit;
    trans_minUnit = trans_min_up;

    return trans_minUnit;
}

